\ ASN1DERerror.f  2015 Mar 03

\ High level error codes
$6080 constant POLARSSL_ERR_CIPHER_FEATURE_UNAVAILABLE          \ CIPHER - The selected feature is not available 
$6100 constant POLARSSL_ERR_CIPHER_BAD_INPUT_DATA               \ CIPHER - Bad input parameters to function 
$6180 constant POLARSSL_ERR_CIPHER_ALLOC_FAILED                 \ CIPHER - Failed to allocate memory 
$6200 constant POLARSSL_ERR_CIPHER_INVALID_PADDING              \ CIPHER - Input data contains invalid padding and is rejected 
$6280 constant POLARSSL_ERR_CIPHER_FULL_BLOCK_EXPECTED          \ CIPHER - Decryption of block requires a full block 
$6300 constant POLARSSL_ERR_CIPHER_AUTH_FAILED                  \ CIPHER - Authentication failed (for AEAD modes) 
                                                                        
$3080 constant POLARSSL_ERR_DHM_BAD_INPUT_DATA                  \ DHM - Bad input parameters to function 
$3100 constant POLARSSL_ERR_DHM_READ_PARAMS_FAILED              \ DHM - Reading of the DHM parameters failed 
$3180 constant POLARSSL_ERR_DHM_MAKE_PARAMS_FAILED              \ DHM - Making of the DHM parameters failed 
$3200 constant POLARSSL_ERR_DHM_READ_PUBLIC_FAILED              \ DHM - Reading of the public values failed 
$3280 constant POLARSSL_ERR_DHM_MAKE_PUBLIC_FAILED              \ DHM - Making of the public value failed 
$3300 constant POLARSSL_ERR_DHM_CALC_SECRET_FAILED              \ DHM - Calculation of the DHM secret failed 
$3380 constant POLARSSL_ERR_DHM_INVALID_FORMAT                  \ DHM - The ASN.1 data is not formatted correctly 
$3400 constant POLARSSL_ERR_DHM_MALLOC_FAILED                   \ DHM - Allocation of memory failed 
$3480 constant POLARSSL_ERR_DHM_FILE_IO_ERROR                   \ DHM - Read/write of file failed 
                                                                        
$4F80 constant POLARSSL_ERR_ECP_BAD_INPUT_DATA                  \ ECP - Bad input parameters to function 
$4F00 constant POLARSSL_ERR_ECP_BUFFER_TOO_SMALL                \ ECP - The buffer is too small to write to 
$4E80 constant POLARSSL_ERR_ECP_FEATURE_UNAVAILABLE             \ ECP - Requested curve not available 
$4E00 constant POLARSSL_ERR_ECP_VERIFY_FAILED                   \ ECP - The signature is not valid 
$4D80 constant POLARSSL_ERR_ECP_MALLOC_FAILED                   \ ECP - Memory allocation failed 
$4D00 constant POLARSSL_ERR_ECP_RANDOM_FAILED                   \ ECP - Generation of random value, such as (ephemeral) key, failed 
$4C80 constant POLARSSL_ERR_ECP_INVALID_KEY                     \ ECP - Invalid private or public key 
$4C00 constant POLARSSL_ERR_ECP_SIG_LEN_MISMATCH                \ ECP - Signature is valid but shorter than the user-supplied length 
                                                                        
$5080 constant POLARSSL_ERR_MD_FEATURE_UNAVAILABLE              \ MD - The selected feature is not available 
$5100 constant POLARSSL_ERR_MD_BAD_INPUT_DATA                   \ MD - Bad input parameters to function 
$5180 constant POLARSSL_ERR_MD_ALLOC_FAILED                     \ MD - Failed to allocate memory 
$5200 constant POLARSSL_ERR_MD_FILE_IO_ERROR                    \ MD - Opening or reading of file failed 
                                                                        
$1080 constant POLARSSL_ERR_PEM_NO_HEADER_FOOTER_PRESENT        \ PEM - No PEM header or footer found 
$1100 constant POLARSSL_ERR_PEM_INVALID_DATA                    \ PEM - PEM string is not as expected 
$1180 constant POLARSSL_ERR_PEM_MALLOC_FAILED                   \ PEM - Failed to allocate memory 
$1200 constant POLARSSL_ERR_PEM_INVALID_ENC_IV                  \ PEM - RSA IV is not in hex-format 
$1280 constant POLARSSL_ERR_PEM_UNKNOWN_ENC_ALG                 \ PEM - Unsupported key encryption algorithm 
$1300 constant POLARSSL_ERR_PEM_PASSWORD_REQUIRED               \ PEM - Private key password can't be empty 
$1380 constant POLARSSL_ERR_PEM_PASSWORD_MISMATCH               \ PEM - Given private key password does not allow for correct decryption 
$1400 constant POLARSSL_ERR_PEM_FEATURE_UNAVAILABLE             \ PEM - Unavailable feature, e.g. hashing/encryption combination 
$1480 constant POLARSSL_ERR_PEM_BAD_INPUT_DATA                  \ PEM - Bad input parameters to function 
                                                                        
$2F80 constant POLARSSL_ERR_PK_MALLOC_FAILED                    \ PK - Memory alloation failed 
$2F00 constant POLARSSL_ERR_PK_TYPE_MISMATCH                    \ PK - Type mismatch, eg attempt to encrypt with an ECDSA key 
$2E80 constant POLARSSL_ERR_PK_BAD_INPUT_DATA                   \ PK - Bad input parameters to function 
$2E00 constant POLARSSL_ERR_PK_FILE_IO_ERROR                    \ PK - Read/write of file failed 
$2D80 constant POLARSSL_ERR_PK_KEY_INVALID_VERSION              \ PK - Unsupported key version 
$2D00 constant POLARSSL_ERR_PK_KEY_INVALID_FORMAT               \ PK - Invalid key tag or value 
$2C80 constant POLARSSL_ERR_PK_UNKNOWN_PK_ALG                   \ PK - Key algorithm is unsupported (only RSA and EC are supported) 
$2C00 constant POLARSSL_ERR_PK_PASSWORD_REQUIRED                \ PK - Private key password can't be empty 
$2B80 constant POLARSSL_ERR_PK_PASSWORD_MISMATCH                \ PK - Given private key password does not allow for correct decryption 
$2B00 constant POLARSSL_ERR_PK_INVALID_PUBKEY                   \ PK - The pubkey tag or value is invalid (only RSA and EC are supported) 
$2A80 constant POLARSSL_ERR_PK_INVALID_ALG                      \ PK - The algorithm tag or value is invalid 
$2A00 constant POLARSSL_ERR_PK_UNKNOWN_NAMED_CURVE              \ PK - Elliptic curve is unsupported (only NIST curves are supported) 
$2980 constant POLARSSL_ERR_PK_FEATURE_UNAVAILABLE              \ PK - Unavailable feature, e.g. RSA disabled for RSA key 
$2000 constant POLARSSL_ERR_PK_SIG_LEN_MISMATCH                 \ PK - The signature is valid but its length is less than expected 
                                                                        
$1F80 constant POLARSSL_ERR_PKCS12_BAD_INPUT_DATA               \ PKCS12 - Bad input parameters to function 
$1F00 constant POLARSSL_ERR_PKCS12_FEATURE_UNAVAILABLE          \ PKCS12 - Feature not available, e.g. unsupported encryption scheme 
$1E80 constant POLARSSL_ERR_PKCS12_PBE_INVALID_FORMAT           \ PKCS12 - PBE ASN.1 data not as expected 
$1E00 constant POLARSSL_ERR_PKCS12_PASSWORD_MISMATCH            \ PKCS12 - Given private key password does not allow for correct decryption 
                                                                        
$3f80 constant POLARSSL_ERR_PKCS5_BAD_INPUT_DATA                \ PKCS5 - Bad input parameters to function 
$3f00 constant POLARSSL_ERR_PKCS5_INVALID_FORMAT                \ PKCS5 - Unexpected ASN.1 data 
$3e80 constant POLARSSL_ERR_PKCS5_FEATURE_UNAVAILABLE           \ PKCS5 - Requested encryption or digest alg not available 
$3e00 constant POLARSSL_ERR_PKCS5_PASSWORD_MISMATCH             \ PKCS5 - Given private key password does not allow for correct decryption 
                                                                        
$4080 constant POLARSSL_ERR_RSA_BAD_INPUT_DATA                  \ RSA - Bad input parameters to function 
$4100 constant POLARSSL_ERR_RSA_INVALID_PADDING                 \ RSA - Input data contains invalid padding and is rejected 
$4180 constant POLARSSL_ERR_RSA_KEY_GEN_FAILED                  \ RSA - Something failed during generation of a key 
$4200 constant POLARSSL_ERR_RSA_KEY_CHECK_FAILED                \ RSA - Key failed to pass the libraries validity check 
$4280 constant POLARSSL_ERR_RSA_PUBLIC_FAILED                   \ RSA - The public key operation failed 
$4300 constant POLARSSL_ERR_RSA_PRIVATE_FAILED                  \ RSA - The private key operation failed 
$4380 constant POLARSSL_ERR_RSA_VERIFY_FAILED                   \ RSA - The PKCS#1 verification failed 
$4400 constant POLARSSL_ERR_RSA_OUTPUT_TOO_LARGE                \ RSA - The output buffer for decryption is not large enough 
$4480 constant POLARSSL_ERR_RSA_RNG_FAILED                      \ RSA - The random generator failed to generate non-zeros 
                                                                        
$7080 constant POLARSSL_ERR_SSL_FEATURE_UNAVAILABLE             \ SSL - The requested feature is not available 
$7100 constant POLARSSL_ERR_SSL_BAD_INPUT_DATA                  \ SSL - Bad input parameters to function 
$7180 constant POLARSSL_ERR_SSL_INVALID_MAC                     \ SSL - Verification of the message MAC failed 
$7200 constant POLARSSL_ERR_SSL_INVALID_RECORD                  \ SSL - An invalid SSL record was received 
$7280 constant POLARSSL_ERR_SSL_CONN_EOF                        \ SSL - The connection indicated an EOF 
$7300 constant POLARSSL_ERR_SSL_UNKNOWN_CIPHER                  \ SSL - An unknown cipher was received 
$7380 constant POLARSSL_ERR_SSL_NO_CIPHER_CHOSEN                \ SSL - The server has no ciphersuites in common with the client 
$7400 constant POLARSSL_ERR_SSL_NO_RNG                          \ SSL - No RNG was provided to the SSL module 
$7480 constant POLARSSL_ERR_SSL_NO_CLIENT_CERTIFICATE           \ SSL - No client certification received from the client, but required by the authentication mode 
$7500 constant POLARSSL_ERR_SSL_CERTIFICATE_TOO_LARGE           \ SSL - Our own certificate(s) is/are too large to send in an SSL message 
$7580 constant POLARSSL_ERR_SSL_CERTIFICATE_REQUIRED            \ SSL - The own certificate is not set, but needed by the server 
$7600 constant POLARSSL_ERR_SSL_PRIVATE_KEY_REQUIRED            \ SSL - The own private key or pre-shared key is not set, but needed 
$7680 constant POLARSSL_ERR_SSL_CA_CHAIN_REQUIRED               \ SSL - No CA Chain is set, but required to operate 
$7700 constant POLARSSL_ERR_SSL_UNEXPECTED_MESSAGE              \ SSL - An unexpected message was received from our peer 
$7780 constant POLARSSL_ERR_SSL_FATAL_ALERT_MESSAGE             \ SSL - A fatal alert message was received from our peer                                                                        
$7800 constant POLARSSL_ERR_SSL_PEER_VERIFY_FAILED              \ SSL - Verification of our peer failed 
$7880 constant POLARSSL_ERR_SSL_PEER_CLOSE_NOTIFY               \ SSL - The peer notified us that the connection is going to be closed 
$7900 constant POLARSSL_ERR_SSL_BAD_HS_CLIENT_HELLO             \ SSL - Processing of the ClientHello handshake message failed 
$7980 constant POLARSSL_ERR_SSL_BAD_HS_SERVER_HELLO             \ SSL - Processing of the ServerHello handshake message failed 
$7A00 constant POLARSSL_ERR_SSL_BAD_HS_CERTIFICATE              \ SSL - Processing of the Certificate handshake message failed 
$7A80 constant POLARSSL_ERR_SSL_BAD_HS_CERTIFICATE_REQUEST      \ SSL - Processing of the CertificateRequest handshake message failed 
$7B00 constant POLARSSL_ERR_SSL_BAD_HS_SERVER_KEY_EXCHANGE      \ SSL - Processing of the ServerKeyExchange handshake message failed 
$7B80 constant POLARSSL_ERR_SSL_BAD_HS_SERVER_HELLO_DONE        \ SSL - Processing of the ServerHelloDone handshake message failed 
$7C00 constant POLARSSL_ERR_SSL_BAD_HS_CLIENT_KEY_EXCHANGE      \ SSL - Processing of the ClientKeyExchange handshake message failed 
$7C80 constant POLARSSL_ERR_SSL_BAD_HS_CLIENT_KEY_EXCHANGE_RP   \ SSL - Processing of the ClientKeyExchange handshake message failed in DHM / ECDH Read Public 
$7D00 constant POLARSSL_ERR_SSL_BAD_HS_CLIENT_KEY_EXCHANGE_CS   \ SSL - Processing of the ClientKeyExchange handshake message failed in DHM / ECDH Calculate Secret 
$7D80 constant POLARSSL_ERR_SSL_BAD_HS_CERTIFICATE_VERIFY       \ SSL - Processing of the CertificateVerify handshake message failed 
$7E00 constant POLARSSL_ERR_SSL_BAD_HS_CHANGE_CIPHER_SPEC       \ SSL - Processing of the ChangeCipherSpec handshake message failed 
$7E80 constant POLARSSL_ERR_SSL_BAD_HS_FINISHED                 \ SSL - Processing of the Finished handshake message failed 
$7F00 constant POLARSSL_ERR_SSL_MALLOC_FAILED                   \ SSL - Memory allocation failed 
$7F80 constant POLARSSL_ERR_SSL_HW_ACCEL_FAILED                 \ SSL - Hardware acceleration function returned with error 
$6F80 constant POLARSSL_ERR_SSL_HW_ACCEL_FALLTHROUGH            \ SSL - Hardware acceleration function skipped / left alone data 
$6F00 constant POLARSSL_ERR_SSL_COMPRESSION_FAILED              \ SSL - Processing of the compression / decompression failed 
$6E80 constant POLARSSL_ERR_SSL_BAD_HS_PROTOCOL_VERSION         \ SSL - Handshake protocol not within min/max boundaries 
$6E00 constant POLARSSL_ERR_SSL_BAD_HS_NEW_SESSION_TICKET       \ SSL - Processing of the NewSessionTicket handshake message failed 
$6D80 constant POLARSSL_ERR_SSL_SESSION_TICKET_EXPIRED          \ SSL - Session ticket has expired 
$6D00 constant POLARSSL_ERR_SSL_PK_TYPE_MISMATCH                \ SSL - Public key type mismatch (eg, asked for RSA key exchange and presented EC key) 
$6C80 constant POLARSSL_ERR_SSL_UNKNOWN_IDENTITY                \ SSL - Unknown identity received (eg, PSK identity) 
$6C00 constant POLARSSL_ERR_SSL_INTERNAL_ERROR                  \ SSL - Internal error (eg, unexpected failure in lower-level module) 
$6B80 constant POLARSSL_ERR_SSL_COUNTER_WRAPPING                \ SSL - A counter would wrap (eg, too many messages exchanged) 
$6B00 constant POLARSSL_ERR_SSL_WAITING_SERVER_HELLO_RENEGO     \ SSL - Unexpected message at ServerHello in renegotiation 
$6A80 constant POLARSSL_ERR_SSL_NO_USABLE_CIPHERSUITE           \ SSL - None of the common ciphersuites is usable (eg, no suitable certificate, see debug messages) 
                                                                        
$2080 constant POLARSSL_ERR_X509_FEATURE_UNAVAILABLE            \ X509 - Unavailable feature, e.g. RSA hashing/encryption combination 
$2100 constant POLARSSL_ERR_X509_UNKNOWN_OID                    \ X509 - Requested OID is unknown 
$2180 constant POLARSSL_ERR_X509_INVALID_FORMAT                 \ X509 - The CRT/CRL/CSR format is invalid, e.g. different type expected 
$2200 constant POLARSSL_ERR_X509_INVALID_VERSION                \ X509 - The CRT/CRL/CSR version element is invalid 
$2280 constant POLARSSL_ERR_X509_INVALID_SERIAL                 \ X509 - The serial tag or value is invalid 
$2300 constant POLARSSL_ERR_X509_INVALID_ALG                    \ X509 - The algorithm tag or value is invalid 
$2380 constant POLARSSL_ERR_X509_INVALID_NAME                   \ X509 - The name tag or value is invalid 
$2400 constant POLARSSL_ERR_X509_INVALID_DATE                   \ X509 - The date tag or value is invalid 
$2480 constant POLARSSL_ERR_X509_INVALID_SIGNATURE              \ X509 - The signature tag or value invalid 
$2500 constant POLARSSL_ERR_X509_INVALID_EXTENSIONS             \ X509 - The extension tag or value is invalid 
$2580 constant POLARSSL_ERR_X509_UNKNOWN_VERSION                \ X509 - CRT/CRL/CSR has an unsupported version number 
$2600 constant POLARSSL_ERR_X509_UNKNOWN_SIG_ALG                \ X509 - Signature algorithm (oid) is unsupported 
$2680 constant POLARSSL_ERR_X509_SIG_MISMATCH                   \ X509 - Signature algorithms do not match. (see \\c ::x509_crt sig_oid) 
$2700 constant POLARSSL_ERR_X509_CERT_VERIFY_FAILED             \ X509 - Certificate verification failed, e.g. CRL, CA or signature check failed 
$2780 constant POLARSSL_ERR_X509_CERT_UNKNOWN_FORMAT            \ X509 - Format not recognized as DER or PEM 
$2800 constant POLARSSL_ERR_X509_BAD_INPUT_DATA                 \ X509 - Input invalid 
$2880 constant POLARSSL_ERR_X509_MALLOC_FAILED                  \ X509 - Allocation of memory failed 
$2900 constant POLARSSL_ERR_X509_FILE_IO_ERROR                  \ X509 - Read/write of file failed 
                                                                        
\           Low level error codes                                       
$0020 constant  POLARSSL_ERR_AES_INVALID_KEY_LENGTH                \ AES - Invalid key length 
$0022 constant  POLARSSL_ERR_AES_INVALID_INPUT_LENGTH              \ AES - Invalid data input length 
                                                                        
$0060 constant  POLARSSL_ERR_ASN1_OUT_OF_DATA                      \ ASN1 - Out of data when parsing an ASN1 data structure 
$0062 constant  POLARSSL_ERR_ASN1_UNEXPECTED_TAG                   \ ASN1 - ASN1 tag was of an unexpected value 
$0064 constant  POLARSSL_ERR_ASN1_INVALID_LENGTH                   \ ASN1 - Error when trying to determine the length or invalid length 
$0066 constant  POLARSSL_ERR_ASN1_LENGTH_MISMATCH                  \ ASN1 - Actual length differs from expected length 
$0068 constant  POLARSSL_ERR_ASN1_INVALID_DATA                     \ ASN1 - Data is invalid. (not used) 
$006A constant  POLARSSL_ERR_ASN1_MALLOC_FAILED                    \ ASN1 - Memory allocation failed 
$006C constant  POLARSSL_ERR_ASN1_BUF_TOO_SMALL                    \ ASN1 - Buffer too small when writing ASN.1 data structure 
                                                                        
$002A constant  POLARSSL_ERR_BASE64_BUFFER_TOO_SMALL               \ BASE64 - Output buffer too small 
$002C constant  POLARSSL_ERR_BASE64_INVALID_CHARACTER              \ BASE64 - Invalid character in input 
                                                                        
$0002 constant  POLARSSL_ERR_MPI_FILE_IO_ERROR                     \ BIGNUM - An error occurred while reading from or writing to a file 
$0004 constant  POLARSSL_ERR_MPI_BAD_INPUT_DATA                    \ BIGNUM - Bad input parameters to function 
$0006 constant  POLARSSL_ERR_MPI_INVALID_CHARACTER                 \ BIGNUM - There is an invalid character in the digit string 
$0008 constant  POLARSSL_ERR_MPI_BUFFER_TOO_SMALL                  \ BIGNUM - The buffer is too small to write to 
$000A constant  POLARSSL_ERR_MPI_NEGATIVE_VALUE                    \ BIGNUM - The input arguments are negative or result in illegal output 
$000C constant  POLARSSL_ERR_MPI_DIVISION_BY_ZERO                  \ BIGNUM - The input argument for division is zero, which is not allowed 
$000E constant  POLARSSL_ERR_MPI_NOT_ACCEPTABLE                    \ BIGNUM - The input arguments are not acceptable 
$0010 constant  POLARSSL_ERR_MPI_MALLOC_FAILED                     \ BIGNUM - Memory allocation failed 
                                                                        
$0016 constant  POLARSSL_ERR_BLOWFISH_INVALID_KEY_LENGTH           \ BLOWFISH - Invalid key length 
$0018 constant  POLARSSL_ERR_BLOWFISH_INVALID_INPUT_LENGTH         \ BLOWFISH - Invalid data input length 
                                                                        
$0024 constant  POLARSSL_ERR_CAMELLIA_INVALID_KEY_LENGTH           \ CAMELLIA - Invalid key length 
$0026 constant  POLARSSL_ERR_CAMELLIA_INVALID_INPUT_LENGTH         \ CAMELLIA - Invalid data input length 
                                                                        
$000D constant  POLARSSL_ERR_CCM_BAD_INPUT                         \ CCM - Bad input parameters to function 
$000F constant  POLARSSL_ERR_CCM_AUTH_FAILED                       \ CCM - Authenticated decryption failed 
                                                                        
$0034 constant  POLARSSL_ERR_CTR_DRBG_ENTROPY_SOURCE_FAILED        \ CTR_DRBG - The entropy source failed 
$0036 constant  POLARSSL_ERR_CTR_DRBG_REQUEST_TOO_BIG              \ CTR_DRBG - Too many random requested in single call 
$0038 constant  POLARSSL_ERR_CTR_DRBG_INPUT_TOO_BIG                \ CTR_DRBG - Input too large (Entropy + additional) 
$003A constant  POLARSSL_ERR_CTR_DRBG_FILE_IO_ERROR                \ CTR_DRBG - Read/write error in file 
                                                                        
$0032 constant  POLARSSL_ERR_DES_INVALID_INPUT_LENGTH              \ DES - The data input has an invalid length 
                                                                        
$003C constant  POLARSSL_ERR_ENTROPY_SOURCE_FAILED                 \ ENTROPY - Critical entropy source failure 
$003E constant  POLARSSL_ERR_ENTROPY_MAX_SOURCES                   \ ENTROPY - No more sources can be added 
$0040 constant  POLARSSL_ERR_ENTROPY_NO_SOURCES_DEFINED            \ ENTROPY - No sources have been added to poll 
$0058 constant  POLARSSL_ERR_ENTROPY_FILE_IO_ERROR                 \ ENTROPY - Read/write error in file 
                                                                        
$0012 constant  POLARSSL_ERR_GCM_AUTH_FAILED                       \ GCM - Authenticated decryption failed 
$0014 constant  POLARSSL_ERR_GCM_BAD_INPUT                         \ GCM - Bad input parameters to function 
                                                                        
$0003 constant  POLARSSL_ERR_HMAC_DRBG_REQUEST_TOO_BIG             \ HMAC_DRBG - Too many random requested in single call 
$0005 constant  POLARSSL_ERR_HMAC_DRBG_INPUT_TOO_BIG               \ HMAC_DRBG - Input too large (Entropy + additional) 
$0007 constant  POLARSSL_ERR_HMAC_DRBG_FILE_IO_ERROR               \ HMAC_DRBG - Read/write error in file 
$0009 constant  POLARSSL_ERR_HMAC_DRBG_ENTROPY_SOURCE_FAILED       \ HMAC_DRBG - The entropy source failed 
                                                                        
$0070 constant  POLARSSL_ERR_MD2_FILE_IO_ERROR                     \ MD2 - Read/write error in file 
                                                                        
$0072 constant  POLARSSL_ERR_MD4_FILE_IO_ERROR                     \ MD4 - Read/write error in file 
                                                                        
$0074 constant  POLARSSL_ERR_MD5_FILE_IO_ERROR                     \ MD5 - Read/write error in file 
                                                                        
$0056 constant  POLARSSL_ERR_NET_UNKNOWN_HOST                      \ NET - Failed to get an IP address for the given hostname 
$0042 constant  POLARSSL_ERR_NET_SOCKET_FAILED                     \ NET - Failed to open a socket 
$0044 constant  POLARSSL_ERR_NET_CONNECT_FAILED                    \ NET - The connection to the given server / port failed 
$0046 constant  POLARSSL_ERR_NET_BIND_FAILED                       \ NET - Binding of the socket failed 
$0048 constant  POLARSSL_ERR_NET_LISTEN_FAILED                     \ NET - Could not listen on the socket 
$004A constant  POLARSSL_ERR_NET_ACCEPT_FAILED                     \ NET - Could not accept the incoming connection 
$004C constant  POLARSSL_ERR_NET_RECV_FAILED                       \ NET - Reading information from the socket failed 
$004E constant  POLARSSL_ERR_NET_SEND_FAILED                       \ NET - Sending information through the socket failed 
$0050 constant  POLARSSL_ERR_NET_CONN_RESET                        \ NET - Connection was reset by peer 
$0052 constant  POLARSSL_ERR_NET_WANT_READ                         \ NET - Connection requires a read call 
$0054 constant  POLARSSL_ERR_NET_WANT_WRITE                        \ NET - Connection requires a write call 
                                                                        
$002E constant  POLARSSL_ERR_OID_NOT_FOUND                         \ OID - OID is not found 
$000B constant  POLARSSL_ERR_OID_BUF_TOO_SMALL                     \ OID - output buffer is too small 
                                                                        
$0030 constant  POLARSSL_ERR_PADLOCK_DATA_MISALIGNED               \ PADLOCK - Input data should be aligned 
                                                                        
$007C constant  POLARSSL_ERR_PBKDF2_BAD_INPUT_DATA                 \ PBKDF2 - Bad input parameters to function 
                                                                        
$007E constant  POLARSSL_ERR_RIPEMD160_FILE_IO_ERROR               \ RIPEMD160 - Read/write error in file 
                                                                        
$0076 constant  POLARSSL_ERR_SHA1_FILE_IO_ERROR                    \ SHA1 - Read/write error in file 
                                                                        
$0078 constant  POLARSSL_ERR_SHA256_FILE_IO_ERROR                  \ SHA256 - Read/write error in file 
                                                                        
$007A constant  POLARSSL_ERR_SHA512_FILE_IO_ERROR                  \ SHA512 - Read/write error in file 
                                                                        
$001A constant  POLARSSL_ERR_THREADING_FEATURE_UNAVAILABLE         \ THREADING - The selected feature is not available 
$001C constant  POLARSSL_ERR_THREADING_BAD_INPUT_DATA              \ THREADING - Bad input parameters to function 
$001E constant  POLARSSL_ERR_THREADING_MUTEX_ERROR                 \ THREADING - Locking / unlocking / free failed with error code 
                                                                        
$0028 constant  POLARSSL_ERR_XTEA_INVALID_INPUT_LENGTH             \ XTEA - The data input has an invalid length 


\ High level error codes
: ASN1DERerrorHighLevel ( u -- $ )
      abs  $FF80 and case
      0                                                of  0 0 ( no error )  endof \ 
      POLARSSL_ERR_CIPHER_FEATURE_UNAVAILABLE          of  s" CIPHER - The selected feature is not available"  endof \ 
      POLARSSL_ERR_CIPHER_BAD_INPUT_DATA               of  s" CIPHER - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_CIPHER_ALLOC_FAILED                 of  s" CIPHER - Failed to allocate memory"  endof \ 
      POLARSSL_ERR_CIPHER_INVALID_PADDING              of  s" CIPHER - Input data contains invalid padding and is rejected"  endof \ 
      POLARSSL_ERR_CIPHER_FULL_BLOCK_EXPECTED          of  s" CIPHER - Decryption of block requires a full block"  endof \ 
      POLARSSL_ERR_CIPHER_AUTH_FAILED                  of  s" CIPHER - Authentication failed (for AEAD modes)"  endof \ 

      POLARSSL_ERR_DHM_BAD_INPUT_DATA                  of  s" DHM - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_DHM_READ_PARAMS_FAILED              of  s" DHM - Reading of the DHM parameters failed"  endof \ 
      POLARSSL_ERR_DHM_MAKE_PARAMS_FAILED              of  s" DHM - Making of the DHM parameters failed"  endof \ 
      POLARSSL_ERR_DHM_READ_PUBLIC_FAILED              of  s" DHM - Reading of the public values failed"  endof \ 
      POLARSSL_ERR_DHM_MAKE_PUBLIC_FAILED              of  s" DHM - Making of the public value failed"  endof \ 
      POLARSSL_ERR_DHM_CALC_SECRET_FAILED              of  s" DHM - Calculation of the DHM secret failed"  endof \ 
      POLARSSL_ERR_DHM_INVALID_FORMAT                  of  s" DHM - The ASN.1 data is not formatted correctly"  endof \ 
      POLARSSL_ERR_DHM_MALLOC_FAILED                   of  s" DHM - Allocation of memory failed"  endof \ 
      POLARSSL_ERR_DHM_FILE_IO_ERROR                   of  s" DHM - Read/write of file failed"  endof \ 

      POLARSSL_ERR_ECP_BAD_INPUT_DATA                  of  s" ECP - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_ECP_BUFFER_TOO_SMALL                of  s" ECP - The buffer is too small to write to"  endof \ 
      POLARSSL_ERR_ECP_FEATURE_UNAVAILABLE             of  s" ECP - Requested curve not available"  endof \ 
      POLARSSL_ERR_ECP_VERIFY_FAILED                   of  s" ECP - The signature is not valid"  endof \ 
      POLARSSL_ERR_ECP_MALLOC_FAILED                   of  s" ECP - Memory allocation failed"  endof \ 
      POLARSSL_ERR_ECP_RANDOM_FAILED                   of  s" ECP - Generation of random value, such as (ephemeral) key, failed"  endof \ 
      POLARSSL_ERR_ECP_INVALID_KEY                     of  s" ECP - Invalid private or public key"  endof \ 
      POLARSSL_ERR_ECP_SIG_LEN_MISMATCH                of  s" ECP - Signature is valid but shorter than the user-supplied length"  endof \ 

      POLARSSL_ERR_MD_FEATURE_UNAVAILABLE              of  s" MD - The selected feature is not available"  endof \ 
      POLARSSL_ERR_MD_BAD_INPUT_DATA                   of  s" MD - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_MD_ALLOC_FAILED                     of  s" MD - Failed to allocate memory"  endof \ 
      POLARSSL_ERR_MD_FILE_IO_ERROR                    of  s" MD - Opening or reading of file failed"  endof \ 

      POLARSSL_ERR_PEM_NO_HEADER_FOOTER_PRESENT        of  s" PEM - No PEM header or footer found"  endof \ 
      POLARSSL_ERR_PEM_INVALID_DATA                    of  s" PEM - PEM string is not as expected"  endof \ 
      POLARSSL_ERR_PEM_MALLOC_FAILED                   of  s" PEM - Failed to allocate memory"  endof \ 
      POLARSSL_ERR_PEM_INVALID_ENC_IV                  of  s" PEM - RSA IV is not in hex-format"  endof \ 
      POLARSSL_ERR_PEM_UNKNOWN_ENC_ALG                 of  s" PEM - Unsupported key encryption algorithm"  endof \ 
      POLARSSL_ERR_PEM_PASSWORD_REQUIRED               of  s" PEM - Private key password can't be empty"  endof \ 
      POLARSSL_ERR_PEM_PASSWORD_MISMATCH               of  s" PEM - Given private key password does not allow for correct decryption"  endof \ 
      POLARSSL_ERR_PEM_FEATURE_UNAVAILABLE             of  s" PEM - Unavailable feature, e.g. hashing/encryption combination"  endof \ 
      POLARSSL_ERR_PEM_BAD_INPUT_DATA                  of  s" PEM - Bad input parameters to function"  endof \ 

      POLARSSL_ERR_PK_MALLOC_FAILED                    of  s" PK - Memory alloation failed"  endof \ 
      POLARSSL_ERR_PK_TYPE_MISMATCH                    of  s" PK - Type mismatch, eg attempt to encrypt with an ECDSA key"  endof \ 
      POLARSSL_ERR_PK_BAD_INPUT_DATA                   of  s" PK - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_PK_FILE_IO_ERROR                    of  s" PK - Read/write of file failed"  endof \ 
      POLARSSL_ERR_PK_KEY_INVALID_VERSION              of  s" PK - Unsupported key version"  endof \ 
      POLARSSL_ERR_PK_KEY_INVALID_FORMAT               of  s" PK - Invalid key tag or value"  endof \ 
      POLARSSL_ERR_PK_UNKNOWN_PK_ALG                   of  s" PK - Key algorithm is unsupported (only RSA and EC are supported)"  endof \ 
      POLARSSL_ERR_PK_PASSWORD_REQUIRED                of  s" PK - Private key password can't be empty"  endof \ 
      POLARSSL_ERR_PK_PASSWORD_MISMATCH                of  s" PK - Given private key password does not allow for correct decryption"  endof \ 
      POLARSSL_ERR_PK_INVALID_PUBKEY                   of  s" PK - The pubkey tag or value is invalid (only RSA and EC are supported)"  endof \ 
      POLARSSL_ERR_PK_INVALID_ALG                      of  s" PK - The algorithm tag or value is invalid"  endof \ 
      POLARSSL_ERR_PK_UNKNOWN_NAMED_CURVE              of  s" PK - Elliptic curve is unsupported (only NIST curves are supported)"  endof \ 
      POLARSSL_ERR_PK_FEATURE_UNAVAILABLE              of  s" PK - Unavailable feature, e.g. RSA disabled for RSA key"  endof \ 
      POLARSSL_ERR_PK_SIG_LEN_MISMATCH                 of  s" PK - The signature is valid but its length is less than expected"  endof \ 

      POLARSSL_ERR_PKCS12_BAD_INPUT_DATA               of  s" PKCS12 - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_PKCS12_FEATURE_UNAVAILABLE          of  s" PKCS12 - Feature not available, e.g. unsupported encryption scheme"  endof \ 
      POLARSSL_ERR_PKCS12_PBE_INVALID_FORMAT           of  s" PKCS12 - PBE ASN.1 data not as expected"  endof \ 
      POLARSSL_ERR_PKCS12_PASSWORD_MISMATCH            of  s" PKCS12 - Given private key password does not allow for correct decryption"  endof \ 

      POLARSSL_ERR_PKCS5_BAD_INPUT_DATA                of  s" PKCS5 - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_PKCS5_INVALID_FORMAT                of  s" PKCS5 - Unexpected ASN.1 data"  endof \ 
      POLARSSL_ERR_PKCS5_FEATURE_UNAVAILABLE           of  s" PKCS5 - Requested encryption or digest alg not available"  endof \ 
      POLARSSL_ERR_PKCS5_PASSWORD_MISMATCH             of  s" PKCS5 - Given private key password does not allow for correct decryption"  endof \ 

      POLARSSL_ERR_RSA_BAD_INPUT_DATA                  of  s" RSA - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_RSA_INVALID_PADDING                 of  s" RSA - Input data contains invalid padding and is rejected"  endof \ 
      POLARSSL_ERR_RSA_KEY_GEN_FAILED                  of  s" RSA - Something failed during generation of a key"  endof \ 
      POLARSSL_ERR_RSA_KEY_CHECK_FAILED                of  s" RSA - Key failed to pass the libraries validity check"  endof \ 
      POLARSSL_ERR_RSA_PUBLIC_FAILED                   of  s" RSA - The public key operation failed"  endof \ 
      POLARSSL_ERR_RSA_PRIVATE_FAILED                  of  s" RSA - The private key operation failed"  endof \ 
      POLARSSL_ERR_RSA_VERIFY_FAILED                   of  s" RSA - The PKCS#1 verification failed"  endof \ 
      POLARSSL_ERR_RSA_OUTPUT_TOO_LARGE                of  s" RSA - The output buffer for decryption is not large enough"  endof \ 
      POLARSSL_ERR_RSA_RNG_FAILED                      of  s" RSA - The random generator failed to generate non-zeros"  endof \ 

      POLARSSL_ERR_SSL_FEATURE_UNAVAILABLE             of  s" SSL - The requested feature is not available"  endof \ 
      POLARSSL_ERR_SSL_BAD_INPUT_DATA                  of  s" SSL - Bad input parameters to function"  endof \ 
      POLARSSL_ERR_SSL_INVALID_MAC                     of  s" SSL - Verification of the message MAC failed"  endof \ 
      POLARSSL_ERR_SSL_INVALID_RECORD                  of  s" SSL - An invalid SSL record was received"  endof \ 
      POLARSSL_ERR_SSL_CONN_EOF                        of  s" SSL - The connection indicated an EOF"  endof \ 
      POLARSSL_ERR_SSL_UNKNOWN_CIPHER                  of  s" SSL - An unknown cipher was received"  endof \ 
      POLARSSL_ERR_SSL_NO_CIPHER_CHOSEN                of  s" SSL - The server has no ciphersuites in common with the client"  endof \ 
      POLARSSL_ERR_SSL_NO_RNG                          of  s" SSL - No RNG was provided to the SSL module"  endof \ 
      POLARSSL_ERR_SSL_NO_CLIENT_CERTIFICATE           of  s" SSL - No client certification received from the client, but required by the authentication mode"  endof \ 
      POLARSSL_ERR_SSL_CERTIFICATE_TOO_LARGE           of  s" SSL - Our own certificate(s) is/are too large to send in an SSL message"  endof \ 
      POLARSSL_ERR_SSL_CERTIFICATE_REQUIRED            of  s" SSL - The own certificate is not set, but needed by the server"  endof \ 
      POLARSSL_ERR_SSL_PRIVATE_KEY_REQUIRED            of  s" SSL - The own private key or pre-shared key is not set, but needed"  endof \ 
      POLARSSL_ERR_SSL_CA_CHAIN_REQUIRED               of  s" SSL - No CA Chain is set, but required to operate"  endof \ 
      POLARSSL_ERR_SSL_UNEXPECTED_MESSAGE              of  s" SSL - An unexpected message was received from our peer"  endof \ 

      POLARSSL_ERR_SSL_FATAL_ALERT_MESSAGE             of  s" SSL - A fatal alert message was received from our peer"  POLARSSL_ERR_SSL_FATAL_ALERT_MESSAGE throw  endof \ 

      POLARSSL_ERR_SSL_PEER_VERIFY_FAILED              of  s" SSL - Verification of our peer failed"  endof \ 
      POLARSSL_ERR_SSL_PEER_CLOSE_NOTIFY               of  s" SSL - The peer notified us that the connection is going to be closed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CLIENT_HELLO             of  s" SSL - Processing of the ClientHello handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_SERVER_HELLO             of  s" SSL - Processing of the ServerHello handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CERTIFICATE              of  s" SSL - Processing of the Certificate handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CERTIFICATE_REQUEST      of  s" SSL - Processing of the CertificateRequest handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_SERVER_KEY_EXCHANGE      of  s" SSL - Processing of the ServerKeyExchange handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_SERVER_HELLO_DONE        of  s" SSL - Processing of the ServerHelloDone handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CLIENT_KEY_EXCHANGE      of  s" SSL - Processing of the ClientKeyExchange handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CLIENT_KEY_EXCHANGE_RP   of  s" SSL - Processing of the ClientKeyExchange handshake message failed in DHM / ECDH Read Public"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CLIENT_KEY_EXCHANGE_CS   of  s" SSL - Processing of the ClientKeyExchange handshake message failed in DHM / ECDH Calculate Secret"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CERTIFICATE_VERIFY       of  s" SSL - Processing of the CertificateVerify handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_CHANGE_CIPHER_SPEC       of  s" SSL - Processing of the ChangeCipherSpec handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_FINISHED                 of  s" SSL - Processing of the Finished handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_MALLOC_FAILED                   of  s" SSL - Memory allocation failed"  endof \ 
      POLARSSL_ERR_SSL_HW_ACCEL_FAILED                 of  s" SSL - Hardware acceleration function returned with error"  endof \ 
      POLARSSL_ERR_SSL_HW_ACCEL_FALLTHROUGH            of  s" SSL - Hardware acceleration function skipped / left alone data"  endof \ 
      POLARSSL_ERR_SSL_COMPRESSION_FAILED              of  s" SSL - Processing of the compression / decompression failed"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_PROTOCOL_VERSION         of  s" SSL - Handshake protocol not within min/max boundaries"  endof \ 
      POLARSSL_ERR_SSL_BAD_HS_NEW_SESSION_TICKET       of  s" SSL - Processing of the NewSessionTicket handshake message failed"  endof \ 
      POLARSSL_ERR_SSL_SESSION_TICKET_EXPIRED          of  s" SSL - Session ticket has expired"  endof \ 
      POLARSSL_ERR_SSL_PK_TYPE_MISMATCH                of  s" SSL - Public key type mismatch (eg, asked for RSA key exchange and presented EC key)"  endof \ 
      POLARSSL_ERR_SSL_UNKNOWN_IDENTITY                of  s" SSL - Unknown identity received (eg, PSK identity)"  endof \ 
      POLARSSL_ERR_SSL_INTERNAL_ERROR                  of  s" SSL - Internal error (eg, unexpected failure in lower-level module)"  endof \ 
      POLARSSL_ERR_SSL_COUNTER_WRAPPING                of  s" SSL - A counter would wrap (eg, too many messages exchanged)"  endof \ 
      POLARSSL_ERR_SSL_WAITING_SERVER_HELLO_RENEGO     of  s" SSL - Unexpected message at ServerHello in renegotiation"  endof \ 
      POLARSSL_ERR_SSL_NO_USABLE_CIPHERSUITE           of  s" SSL - None of the common ciphersuites is usable (eg, no suitable certificate, see debug messages)"  endof \ 

      POLARSSL_ERR_X509_FEATURE_UNAVAILABLE            of  s" X509 - Unavailable feature, e.g. RSA hashing/encryption combination"  endof \ 
      POLARSSL_ERR_X509_UNKNOWN_OID                    of  s" X509 - Requested OID is unknown"  endof \ 
      POLARSSL_ERR_X509_INVALID_FORMAT                 of  s" X509 - The CRT/CRL/CSR format is invalid, e.g. different type expected"  endof \ 
      POLARSSL_ERR_X509_INVALID_VERSION                of  s" X509 - The CRT/CRL/CSR version element is invalid"  endof \ 
      POLARSSL_ERR_X509_INVALID_SERIAL                 of  s" X509 - The serial tag or value is invalid"  endof \ 
      POLARSSL_ERR_X509_INVALID_ALG                    of  s" X509 - The algorithm tag or value is invalid"  endof \ 
      POLARSSL_ERR_X509_INVALID_NAME                   of  s" X509 - The name tag or value is invalid"  endof \ 
      POLARSSL_ERR_X509_INVALID_DATE                   of  s" X509 - The date tag or value is invalid"  endof \ 
      POLARSSL_ERR_X509_INVALID_SIGNATURE              of  s" X509 - The signature tag or value invalid"  endof \ 
      POLARSSL_ERR_X509_INVALID_EXTENSIONS             of  s" X509 - The extension tag or value is invalid"  endof \ 
      POLARSSL_ERR_X509_UNKNOWN_VERSION                of  s" X509 - CRT/CRL/CSR has an unsupported version number"  endof \ 
      POLARSSL_ERR_X509_UNKNOWN_SIG_ALG                of  s" X509 - Signature algorithm (oid) is unsupported"  endof \ 
      POLARSSL_ERR_X509_SIG_MISMATCH                   of  s" X509 - Signature algorithms do not match. (see \\c ::x509_crt sig_oid)"  endof \ 
      POLARSSL_ERR_X509_CERT_VERIFY_FAILED             of  s" X509 - Certificate verification failed, e.g. CRL, CA or signature check failed"  endof \ 
      POLARSSL_ERR_X509_CERT_UNKNOWN_FORMAT            of  s" X509 - Format not recognized as DER or PEM"  endof \ 
      POLARSSL_ERR_X509_BAD_INPUT_DATA                 of  s" X509 - Input invalid"  endof \ 
      POLARSSL_ERR_X509_MALLOC_FAILED                  of  s" X509 - Allocation of memory failed"  endof \ 
      POLARSSL_ERR_X509_FILE_IO_ERROR                  of  s" X509 - Read/write of file failed"  endof \ 

       s" Unknown High Level Error code "  rot
   endcase
;

\ Low level error codes
: ASN1DERerrorLowLevel ( u -- $ )

   abs  $007F and  case

    0                                                  of  0 0 ( no error )  endof \ 
    POLARSSL_ERR_AES_INVALID_KEY_LENGTH                of  s" AES - Invalid key length"  endof \ 
    POLARSSL_ERR_AES_INVALID_INPUT_LENGTH              of  s" AES - Invalid data input length"  endof \ 

    POLARSSL_ERR_ASN1_OUT_OF_DATA                      of  s" ASN1 - Out of data when parsing an ASN1 data structure"  endof \ 
    POLARSSL_ERR_ASN1_UNEXPECTED_TAG                   of  s" ASN1 - ASN1 tag was of an unexpected value"  endof \ 
    POLARSSL_ERR_ASN1_INVALID_LENGTH                   of  s" ASN1 - Error when trying to determine the length or invalid length"  endof \ 
    POLARSSL_ERR_ASN1_LENGTH_MISMATCH                  of  s" ASN1 - Actual length differs from expected length"  endof \ 
    POLARSSL_ERR_ASN1_INVALID_DATA                     of  s" ASN1 - Data is invalid. (not used)"  endof \ 
    POLARSSL_ERR_ASN1_MALLOC_FAILED                    of  s" ASN1 - Memory allocation failed"  endof \ 
    POLARSSL_ERR_ASN1_BUF_TOO_SMALL                    of  s" ASN1 - Buffer too small when writing ASN.1 data structure"  endof \ 

    POLARSSL_ERR_BASE64_BUFFER_TOO_SMALL               of  s" BASE64 - Output buffer too small"  endof \ 
    POLARSSL_ERR_BASE64_INVALID_CHARACTER              of  s" BASE64 - Invalid character in input"  endof \ 

    POLARSSL_ERR_MPI_FILE_IO_ERROR                     of  s" BIGNUM - An error occurred while reading from or writing to a file"  endof \ 
    POLARSSL_ERR_MPI_BAD_INPUT_DATA                    of  s" BIGNUM - Bad input parameters to function"  endof \ 
    POLARSSL_ERR_MPI_INVALID_CHARACTER                 of  s" BIGNUM - There is an invalid character in the digit string"  endof \ 
    POLARSSL_ERR_MPI_BUFFER_TOO_SMALL                  of  s" BIGNUM - The buffer is too small to write to"  endof \ 
    POLARSSL_ERR_MPI_NEGATIVE_VALUE                    of  s" BIGNUM - The input arguments are negative or result in illegal output"  endof \ 
    POLARSSL_ERR_MPI_DIVISION_BY_ZERO                  of  s" BIGNUM - The input argument for division is zero, which is not allowed"  endof \ 
    POLARSSL_ERR_MPI_NOT_ACCEPTABLE                    of  s" BIGNUM - The input arguments are not acceptable"  endof \ 
    POLARSSL_ERR_MPI_MALLOC_FAILED                     of  s" BIGNUM - Memory allocation failed"  endof \ 

    POLARSSL_ERR_BLOWFISH_INVALID_KEY_LENGTH           of  s" BLOWFISH - Invalid key length"  endof \ 
    POLARSSL_ERR_BLOWFISH_INVALID_INPUT_LENGTH         of  s" BLOWFISH - Invalid data input length"  endof \ 

    POLARSSL_ERR_CAMELLIA_INVALID_KEY_LENGTH           of  s" CAMELLIA - Invalid key length"  endof \ 
    POLARSSL_ERR_CAMELLIA_INVALID_INPUT_LENGTH         of  s" CAMELLIA - Invalid data input length"  endof \ 

    POLARSSL_ERR_CCM_BAD_INPUT                         of  s" CCM - Bad input parameters to function"  endof \ 
    POLARSSL_ERR_CCM_AUTH_FAILED                       of  s" CCM - Authenticated decryption failed"  endof \ 

    POLARSSL_ERR_CTR_DRBG_ENTROPY_SOURCE_FAILED        of  s" CTR_DRBG - The entropy source failed"  endof \ 
    POLARSSL_ERR_CTR_DRBG_REQUEST_TOO_BIG              of  s" CTR_DRBG - Too many random requested in single call"  endof \ 
    POLARSSL_ERR_CTR_DRBG_INPUT_TOO_BIG                of  s" CTR_DRBG - Input too large (Entropy + additional)"  endof \ 
    POLARSSL_ERR_CTR_DRBG_FILE_IO_ERROR                of  s" CTR_DRBG - Read/write error in file"  endof \ 

    POLARSSL_ERR_DES_INVALID_INPUT_LENGTH              of  s" DES - The data input has an invalid length"  endof \ 

    POLARSSL_ERR_ENTROPY_SOURCE_FAILED                 of  s" ENTROPY - Critical entropy source failure"  endof \ 
    POLARSSL_ERR_ENTROPY_MAX_SOURCES                   of  s" ENTROPY - No more sources can be added"  endof \ 
    POLARSSL_ERR_ENTROPY_NO_SOURCES_DEFINED            of  s" ENTROPY - No sources have been added to poll"  endof \ 
    POLARSSL_ERR_ENTROPY_FILE_IO_ERROR                 of  s" ENTROPY - Read/write error in file"  endof \ 

    POLARSSL_ERR_GCM_AUTH_FAILED                       of  s" GCM - Authenticated decryption failed"  endof \ 
    POLARSSL_ERR_GCM_BAD_INPUT                         of  s" GCM - Bad input parameters to function"  endof \ 

    POLARSSL_ERR_HMAC_DRBG_REQUEST_TOO_BIG             of  s" HMAC_DRBG - Too many random requested in single call"  endof \ 
    POLARSSL_ERR_HMAC_DRBG_INPUT_TOO_BIG               of  s" HMAC_DRBG - Input too large (Entropy + additional)"  endof \ 
    POLARSSL_ERR_HMAC_DRBG_FILE_IO_ERROR               of  s" HMAC_DRBG - Read/write error in file"  endof \ 
    POLARSSL_ERR_HMAC_DRBG_ENTROPY_SOURCE_FAILED       of  s" HMAC_DRBG - The entropy source failed"  endof \ 

    POLARSSL_ERR_MD2_FILE_IO_ERROR                     of  s" MD2 - Read/write error in file"  endof \ 

    POLARSSL_ERR_MD4_FILE_IO_ERROR                     of  s" MD4 - Read/write error in file"  endof \ 

    POLARSSL_ERR_MD5_FILE_IO_ERROR                     of  s" MD5 - Read/write error in file"  endof \ 

    POLARSSL_ERR_NET_UNKNOWN_HOST                      of  s" NET - Failed to get an IP address for the given hostname"  endof \ 
    POLARSSL_ERR_NET_SOCKET_FAILED                     of  s" NET - Failed to open a socket"  endof \ 
    POLARSSL_ERR_NET_CONNECT_FAILED                    of  s" NET - The connection to the given server / port failed"  endof \ 
    POLARSSL_ERR_NET_BIND_FAILED                       of  s" NET - Binding of the socket failed"  endof \ 
    POLARSSL_ERR_NET_LISTEN_FAILED                     of  s" NET - Could not listen on the socket"  endof \ 
    POLARSSL_ERR_NET_ACCEPT_FAILED                     of  s" NET - Could not accept the incoming connection"  endof \ 
    POLARSSL_ERR_NET_RECV_FAILED                       of  s" NET - Reading information from the socket failed"  endof \ 
    POLARSSL_ERR_NET_SEND_FAILED                       of  s" NET - Sending information through the socket failed"  endof \ 
    POLARSSL_ERR_NET_CONN_RESET                        of  s" NET - Connection was reset by peer"  endof \ 
    POLARSSL_ERR_NET_WANT_READ                         of  s" NET - Connection requires a read call"  endof \ 
    POLARSSL_ERR_NET_WANT_WRITE                        of  s" NET - Connection requires a write call"  endof \ 

    POLARSSL_ERR_OID_NOT_FOUND                         of  s" OID - OID is not found"  endof \ 
    POLARSSL_ERR_OID_BUF_TOO_SMALL                     of  s" OID - output buffer is too small"  endof \ 

    POLARSSL_ERR_PADLOCK_DATA_MISALIGNED               of  s" PADLOCK - Input data should be aligned"  endof \ 

    POLARSSL_ERR_PBKDF2_BAD_INPUT_DATA                 of  s" PBKDF2 - Bad input parameters to function"  endof \ 

    POLARSSL_ERR_RIPEMD160_FILE_IO_ERROR               of  s" RIPEMD160 - Read/write error in file"  endof \ 

    POLARSSL_ERR_SHA1_FILE_IO_ERROR                    of  s" SHA1 - Read/write error in file"  endof \ 

    POLARSSL_ERR_SHA256_FILE_IO_ERROR                  of  s" SHA256 - Read/write error in file"  endof \ 

    POLARSSL_ERR_SHA512_FILE_IO_ERROR                  of  s" SHA512 - Read/write error in file"  endof \ 

    POLARSSL_ERR_THREADING_FEATURE_UNAVAILABLE         of  s" THREADING - The selected feature is not available"  endof \ 
    POLARSSL_ERR_THREADING_BAD_INPUT_DATA              of  s" THREADING - Bad input parameters to function"  endof \ 
    POLARSSL_ERR_THREADING_MUTEX_ERROR                 of  s" THREADING - Locking / unlocking / free failed with error code"  endof \ 

    POLARSSL_ERR_XTEA_INVALID_INPUT_LENGTH             of  s" XTEA - The data input has an invalid length"  endof \ 

       s" Unknown Low Level Error code"  rot
   endcase
;

: ShowASN1DERerror ( u -- )
   >r    
   r@ ASN1DERerrorHighLevel dup dup >r if  type  else  2drop  then
   r>   
   r@ ASN1DERerrorLowLevel  dup  if  
      rot if  ."  : "  then 
      type  
   else  
      drop
      2drop  
   then
   r> drop
;

: ShowOneError ( u -- )   dup 4 .hex 2 spaces  BLUE. ShowASN1DERerror  RESTORE. ;

: ttserr
   cr  POLARSSL_ERR_ASN1_OUT_OF_DATA         ShowOneError  
   cr  POLARSSL_ERR_ASN1_UNEXPECTED_TAG      ShowOneError 
   cr  POLARSSL_ERR_ASN1_INVALID_LENGTH      ShowOneError 
   cr  POLARSSL_ERR_ASN1_LENGTH_MISMATCH     ShowOneError 
   cr  POLARSSL_ERR_ASN1_INVALID_DATA        ShowOneError 
   cr  POLARSSL_ERR_ASN1_MALLOC_FAILED       ShowOneError 
   cr  POLARSSL_ERR_ASN1_BUF_TOO_SMALL       ShowOneError 
   cr  POLARSSL_ERR_X509_FEATURE_UNAVAILABLE ShowOneError
   cr  POLARSSL_ERR_X509_UNKNOWN_OID         ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_FORMAT      ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_VERSION     ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_SERIAL      ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_ALG         ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_NAME        ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_DATE        ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_SIGNATURE   ShowOneError
   cr  POLARSSL_ERR_X509_INVALID_EXTENSIONS  ShowOneError
   cr  POLARSSL_ERR_X509_UNKNOWN_VERSION     ShowOneError
   cr  POLARSSL_ERR_X509_UNKNOWN_SIG_ALG     ShowOneError
   cr  POLARSSL_ERR_X509_SIG_MISMATCH        ShowOneError
   cr  POLARSSL_ERR_X509_CERT_VERIFY_FAILED  ShowOneError
   cr  POLARSSL_ERR_X509_CERT_UNKNOWN_FORMAT ShowOneError
   cr  POLARSSL_ERR_X509_BAD_INPUT_DATA      ShowOneError
   cr  POLARSSL_ERR_X509_MALLOC_FAILED       ShowOneError
   cr  POLARSSL_ERR_X509_FILE_IO_ERROR       ShowOneError
   cr  POLARSSL_ERR_X509_SIG_MISMATCH        ShowOneError

   cr  POLARSSL_ERR_X509_CERT_VERIFY_FAILED  POLARSSL_ERR_NET_UNKNOWN_HOST   or ShowOneError
   cr  POLARSSL_ERR_X509_CERT_UNKNOWN_FORMAT POLARSSL_ERR_NET_SOCKET_FAILED  or ShowOneError
   cr  POLARSSL_ERR_X509_BAD_INPUT_DATA      POLARSSL_ERR_NET_CONNECT_FAILED or ShowOneError
   cr  POLARSSL_ERR_X509_MALLOC_FAILED       POLARSSL_ERR_NET_BIND_FAILED    or ShowOneError
   cr  POLARSSL_ERR_X509_FILE_IO_ERROR       POLARSSL_ERR_NET_LISTEN_FAILED  or ShowOneError
;
                                     
