{ ==================================================================
Text.f  text display window  2016 Mar 08
(C) Copyright 2015 Inventio Software Ltd  www.inventio.co.uk
==================================================================== }
\ text screen size
7 2** constant CHARS-PER-LINE    \ must be a power of 2
6 2** constant LINES-PER-SCREEN  \ must be a power of 2

\ #42 constant CHARS-PER-DISPLAYED-LINE
\ #20 constant DISPLAYED-LINES-PER-SCREEN
#98 constant CHARS-PER-DISPLAYED-LINE
#48 constant DISPLAYED-LINES-PER-SCREEN

\ define the lines that scroll on CR
#05 constant TOP-SCROLL-LINE
#48 constant BOTTOM-SCROLL-LINE

variable TheKeyPressed     \ the value of a key when pressed
variable TheKeyPressed#    \ the number of keys queued in the key buffer

2variable vTextForegroundColour
vTextForegroundColour cell+ constant vTextBackgroundColour

2variable vDrawingForegoundColour  
vDrawingForegoundColour cell+ constant vDrawingBackgroundColour

variable vBorderSizeX
variable vBorderSizeY
variable vStatusBarHeight
variable vStatusBarWidth

2variable MousePosition_X   \ the raw coordinates from the mouse driver
MousePosition_X cell+ constant MousePosition_Y

variable WindowSize_X      \ our window size
variable WindowSize_Y

variable MouseX_Chars      \ mouse position in characters
variable MouseY_Chars

variable MouseX_Pixels     \ mouse position in pixels
variable MouseY_Pixels

variable MouseX_4x4        \ mouse position in a 4 x 4 matrix
variable MouseY_4x4

variable MouseButtonsPressed
1 constant LEFT_BUTTON
2 constant LEFT_BUTTON_DOUBLE
4 constant RIGHT_BUTTON
8 constant RIGHT_BUTTON_DOUBLE

variable MenuButtonPressed
variable WhichMenuButtonPressed

variable KeyPressed
variable WhichKeyPressed

: MarkMenuButtonPressed ( enum -- )
   ( enum -- ) WhichMenuButtonPressed !
   1 MenuButtonPressed !
;

: _SPACE  ( -- )   0 EMIT  ;

: _SPACES ( +n -- )   0 ?do  _SPACE  loop ;

\ *****************************************************************************
\ **************************** basic font sizes *******************************
\ *****************************************************************************

\ 42 constant CHARWIDTH
\ 32 constant CHARHEIGHT
8 constant CHARWIDTH
16 constant CHARHEIGHT

variable vNeedAnUpdate

\ something has changed on the display...
: UpdateText
   -1 vNeedAnUpdate !
;

\ send a message to the window to update 
: WinUpdateText
   WM_PAINT 0 0 SendMessage DROP
   0  \ not sure why we need this, but we do need it...
;

\ send a message to the window to update is something has changed
: ?WinUpdateText ( -- )
   vNeedAnUpdate @ if   
      WinUpdateText
   then
;


\ ************************** Main text area **********************************
CHARS-PER-LINE LINES-PER-SCREEN * constant CHARS-PER-SCREEN    \ must be a power of 2

\ text and colour buffers, fixed offset between them
CHARS-PER-SCREEN 2* Buffer: TextBuffer[]
TextBuffer[] CHARS-PER-SCREEN + constant ColourBuffer[] \ one byte per character

CHARS-PER-SCREEN Buffer: saveTextBuffer[]     \ one byte per character
CHARS-PER-SCREEN Buffer: saveColourBuffer[]   \ one byte per character

variable savel#
variable savec#
variable saveCursorCol

\ *****************************************************************************
\ colours
\ *****************************************************************************

: BGR>RGB ( u -- u' )   \ Windows API colour format and pixel colour format are different, it seems...   
   >r
   r@ $0000FF and  $10 lshift 
   r@ $00FF00 and or
   r> $FF0000 and $10 rshift or
   $FF000000 or   \ set the alpha channel too
;

\ system "ATTRIBUTE" colours :
CREATE ColourTable2
\        BACKGROUND  TEXT           
(  0 )   WHITE   BGR>RGB ,   BLACK        BGR>RGB ,  \ normal
(  1 )   BLACK   BGR>RGB ,   WHITE        BGR>RGB ,  \ inverse
(  2 )   WHITE   BGR>RGB ,   RED          BGR>RGB ,  \ bright
(  3 )   WHITE   BGR>RGB ,   BLUE         BGR>RGB ,  \ bold
(  4 )   WHITE   BGR>RGB ,   CYAN         BGR>RGB ,  \
(  5 )   WHITE   BGR>RGB ,   MAGENTA      BGR>RGB ,  \
(  6 )   WHITE   BGR>RGB ,   YELLOW       BGR>RGB ,  \
(  7 )   WHITE   BGR>RGB ,   GREEN        BGR>RGB ,  \
(  8 )   WHITE   BGR>RGB ,   DARK-RED     BGR>RGB ,  \
(  9 )   WHITE   BGR>RGB ,   DARK-GREEN   BGR>RGB ,  \
( 10 )   WHITE   BGR>RGB ,   DARK-YELLOW  BGR>RGB ,  \
( 11 )   WHITE   BGR>RGB ,   DARK-BLUE    BGR>RGB ,  \
( 12 )   WHITE   BGR>RGB ,   DARK-MAGENTA BGR>RGB ,  \
( 13 )   WHITE   BGR>RGB ,   DARK-CYAN    BGR>RGB ,  \
( 14 )   WHITE   BGR>RGB ,   GRAY         BGR>RGB ,  \
( 15 )   WHITE   BGR>RGB ,   DARK-GRAY    BGR>RGB ,  \
( 16 )   YELLOW  BGR>RGB ,   BLACK        BGR>RGB ,  \
( 17 )   CYAN    BGR>RGB ,   BLACK        BGR>RGB ,  \
( 18 )   MAGENTA BGR>RGB ,   BLACK        BGR>RGB ,  \
( 19 )   GREEN   BGR>RGB ,   BLACK        BGR>RGB ,  \
( 20 )   WHITE   BGR>RGB ,   BLACK        BGR>RGB ,  \
( 21 )   BLACK   BGR>RGB ,   WHITE        BGR>RGB ,  \
( 22 )   WHITE   BGR>RGB ,   RED          BGR>RGB ,  \
( 23 )   WHITE   BGR>RGB ,   BLUE         BGR>RGB ,  \
( 24 )   WHITE   BGR>RGB ,   CYAN         BGR>RGB ,  \
( 25 )   WHITE   BGR>RGB ,   MAGENTA      BGR>RGB ,  \
( 26 )   WHITE   BGR>RGB ,   YELLOW       BGR>RGB ,  \
( 27 )   WHITE   BGR>RGB ,   GREEN        BGR>RGB ,  \
( 28 )   WHITE   BGR>RGB ,   DARK-RED     BGR>RGB ,  \
( 29 )   WHITE   BGR>RGB ,   DARK-GREEN   BGR>RGB ,  \
( 30 )   WHITE   BGR>RGB ,   DARK-YELLOW  BGR>RGB ,  \
( 31 )   WHITE   BGR>RGB ,   DARK-BLUE    BGR>RGB ,  \
( 32 )   BLACK        BGR>RGB ,   WHITE   BGR>RGB ,  \
( 33 )   WHITE        BGR>RGB ,   BLACK   BGR>RGB ,  \
( 34 )   RED          BGR>RGB ,   WHITE   BGR>RGB ,  \
( 35 )   BLUE         BGR>RGB ,   WHITE   BGR>RGB ,  \
( 36 )   CYAN         BGR>RGB ,   WHITE   BGR>RGB ,  \
( 37 )   MAGENTA      BGR>RGB ,   WHITE   BGR>RGB ,  \
( 38 )   YELLOW       BGR>RGB ,   WHITE   BGR>RGB ,  \
( 39 )   GREEN        BGR>RGB ,   WHITE   BGR>RGB ,  \
( 40 )   DARK-RED     BGR>RGB ,   WHITE   BGR>RGB ,  \
( 41 )   DARK-GREEN   BGR>RGB ,   WHITE   BGR>RGB ,  \
( 42 )   DARK-YELLOW  BGR>RGB ,   WHITE   BGR>RGB ,  \
( 43 )   DARK-BLUE    BGR>RGB ,   WHITE   BGR>RGB ,  \
( 44 )   DARK-MAGENTA BGR>RGB ,   WHITE   BGR>RGB ,  \
( 45 )   DARK-CYAN    BGR>RGB ,   WHITE   BGR>RGB ,  \
( 46 )   GRAY         BGR>RGB ,   WHITE   BGR>RGB ,  \
( 47 )   DARK-GRAY    BGR>RGB ,   WHITE   BGR>RGB ,  \
( 48 )   BLACK        BGR>RGB ,   YELLOW  BGR>RGB ,  \
( 49 )   BLACK        BGR>RGB ,   CYAN    BGR>RGB ,  \
( 50 )   BLACK        BGR>RGB ,   MAGENTA BGR>RGB ,  \
( 51 )   BLACK        BGR>RGB ,   GREEN   BGR>RGB ,  \
( 52 )   BLACK        BGR>RGB ,   WHITE   BGR>RGB ,  \
( 53 )   WHITE        BGR>RGB ,   BLACK   BGR>RGB ,  \
( 54 )   RED          BGR>RGB ,   WHITE   BGR>RGB ,  \
( 55 )   BLUE         BGR>RGB ,   WHITE   BGR>RGB ,  \
( 56 )   CYAN         BGR>RGB ,   WHITE   BGR>RGB ,  \
( 57 )   MAGENTA      BGR>RGB ,   WHITE   BGR>RGB ,  \
( 58 )   YELLOW       BGR>RGB ,   WHITE   BGR>RGB ,  \
( 59 )   GREEN        BGR>RGB ,   WHITE   BGR>RGB ,  \
( 60 )   DARK-RED     BGR>RGB ,   WHITE   BGR>RGB ,  \
( 61 )   DARK-GREEN   BGR>RGB ,   WHITE   BGR>RGB ,  \
( 62 )   DARK-YELLOW  BGR>RGB ,   WHITE   BGR>RGB ,  \
( 63 )   DARK-BLUE    BGR>RGB ,   WHITE   BGR>RGB ,  \

: >RGB ( n - rgbForeground rgbBackground )   cells 2* ColourTable2 + 2@ ;

$00 CONSTANT DefaultvATTRIBUTE \ black text on a white background

VARIABLE vATTRIBUTE  DefaultvATTRIBUTE vATTRIBUTE !

{ 

variable SavedvATTRIBUTE
\ 2variable SavedXY


: SaveAttributes
   vATTRIBUTE @ SavedvATTRIBUTE !
   GET-XY SavedXY 2!
;

: RestoreAttributes
   SavedXY 2@ At-XY
   SavedvATTRIBUTE @ vATTRIBUTE !
;

\ clear the message line
: \MSG
   0 LINES-PER-SCREEN 1-  2DUP  At-XY 
   CHARS-PER-LINE SPACES  
   At-XY 
;
: MSG[  SaveAttributes 7 ATTRIBUTE  \MSG ;

: ]MSG   RestoreAttributes ;
}

\ *****************************************************************************
\ The TextBuffer[] , containing 8 bit ASCII characters and 8 bit colour attribute
\ similar to DOS EGA screens
\ Writing a character using emit(T) will update this buffer, the TextBuffer[]
\ will then get drawn to the bitmap display
\ *****************************************************************************

\ returns the address of the character  at line l# , column c# in the TexBuffer[]
: >TextBuffer ( l# c# -- a )
   swap CHARS-PER-LINE * +  CHARS-PER-SCREEN 1- and 
   TextBuffer[] +
;


\ returns the address of the character at the current line and column 
: >TextBufferChar ( -- c-addr )
   l# @ c# @  >TextBuffer
;

\ returns the address of the colour at the current line and column 
: >TextBufferColour        \ -- c-addr
   >TextBufferChar CHARS-PER-SCREEN +
;

: >TextBufferLine ( n -- a )   0 >TextBuffer ;
: >TextBufferLineColour ( n -- a )   >TextBufferLine CHARS-PER-SCREEN + ;


\ y x  y x -- y x
\ : V+ ( v v - v )   >R  rot +  SWAP  R> + ;


: SaveScreen
   l# @ savel# !
   c# @ savec# !
   TextBuffer[] saveTextBuffer[] CHARS-PER-SCREEN move
   ColourBuffer[] saveColourBuffer[] CHARS-PER-SCREEN move
;

: RestoreScreen
   savel# @ l# !
   savec# @ c# !
   saveTextBuffer[] TextBuffer[] CHARS-PER-SCREEN move
   saveColourBuffer[] ColourBuffer[] CHARS-PER-SCREEN move
;

\ *************

: At-XY(T) ( x y -- )   l# ! c# ! ;
: Get-XY?(T) ( -- x y )   c# @ l# @ ;

: page(T)
   TextBuffer[] CHARS-PER-SCREEN   $20 fill  \ null means do not display this character
   ColourBuffer[] CHARS-PER-SCREEN $00 fill  \ black on white
   0 0 At-XY(T)
   UpdateText
;

: pageText
   TextBuffer[]   CHARS-PER-SCREEN 3 4 */ $20 fill  \ null means do not display this character
   ColourBuffer[] CHARS-PER-SCREEN 3 4 */ $00 fill  \ black on white
   0 0 At-XY(T)
   UpdateText
;


: attribute(T) ( n -- )   vAttribute ! ;

: (scroll)
   BOTTOM-SCROLL-LINE 1- TOP-SCROLL-LINE 1+ do
      i 1+ >TextBufferLine i >TextBufferLine CHARS-PER-LINE move
   loop
   BOTTOM-SCROLL-LINE 1- >TextBufferLine CHARS-PER-LINE $20 fill

   BOTTOM-SCROLL-LINE 1- TOP-SCROLL-LINE 1+ do
      i 1+ >TextBufferLineColour i >TextBufferLineColour CHARS-PER-LINE move
   loop
   BOTTOM-SCROLL-LINE 1- >TextBufferLineColour CHARS-PER-LINE DefaultvATTRIBUTE fill

   UpdateText
;

variable NoScroll 
variable vBigFont

: cr(T)
\ cr action
   0 c# !  l# @ 1+ dup l# !
\   Get-XY(T)  swap drop 0  swap  1+ At-XY(T)

   BOTTOM-SCROLL-LINE 1- > NoScroll @ 0= and if
      (scroll)
      BOTTOM-SCROLL-LINE 1- l# !
   then
   UpdateText
;

: cr-(T)
   0 c# !  l# @  1- 0 max  l# !
\   Get-XY(T)  swap drop 0 swap 1- 0 max At-XY(T)  
;

: BS(T)
\ backspace action
   c# @ 1- 0 max c# !
   $20 >TextBufferChar c!
   UpdateText
;

\ send c to the TextBuffer, marked with the current colour
: emit(T) ( c -- )
   dup $08 = if
      drop
      BS(T)
      exit
   then

   dup >r 
   c# @ 1+ CHARS-PER-DISPLAYED-LINE > 
   r> $0D = or
   if
      drop
      cr(T)
      exit
   else
      1 c# +!
   then
   
   >TextBufferChar >r

   r@ c@ over = not if          \ different character
      r@ c!
      UpdateText
   else
      drop
   then
   r> drop

   >TextBufferColour >r
   r@ c@ vATTRIBUTE c@ = not if  \ different colour
      vATTRIBUTE c@ r@ 
      vBigFont @ if  $80 or  then   \ mark as big font
      c!        \ set the new colour
      UpdateText
   then
   r> drop

\   UpdateText
;

: type(T)         \ c-addr len --
   bounds ?do  i c@ emit(T)  loop
   UpdateText
;


\ *****************************************************************************
\ Write a character to the Bitmap window
\ *****************************************************************************

\ x and y coordinates of the top left corner of the text box
\ 4 constant X-ORG
\ 4 constant Y-ORG

\ The current character top left drawing position in pixels
2variable Cursor_Y
Cursor_Y cell+ constant Cursor_X

variable WinX
variable WinY
variable ptrTextBuffer

\ create MyFont[] ( -- a )   s" icons.fnt" CompileFile  \ the font
\ include Font24x32ubuntu.f
\ include Font12x16vertical.f

\ ******************************************************************************
\  611  Character Fonts
\ ******************************************************************************

#USER    

\ *FONT  holds the values to be multiplied with the current
\    vertical and horizontal font sizes.
\ 2 CELLS +USER *FONT         

\ PROP  maintains the dimensions of a character. 
\ 2 CELLS +USER PROP 

\ 'LOCAL-FONT  holds the address of the current font.
CELL +USER 'LOCAL-FONT  

\ FONT  is passed the address of the string describing the font. 
\ cell +USER 'FONT       
\ : FONT ( n)          'FONT @EXECUTE ; 

\ ******************************************************************************
\  935  Vector arithmetic
\ ******************************************************************************

\ V+  adds 2 vectors and returns the result.
CODE V+ ( v1 v2 -- v3 )
   0 [EBP] EAX MOV                  \ get d2-lo
   8 [EBP] EAX ADD                  \ add d1-lo
   4 [EBP] EBX ADD                  \ add d1-hi and carry to d2-hi
   EAX 8 [EBP] MOV                  \ write d3-low
   8 # EBP ADD                      \ and clean up stack
   RET END-CODE
 
\ V-  subtracts the vector on top of the stack from the vector
\    below it, returning the result.
CODE V- ( v1 v2 -- v3 )
   8 [EBP] EAX MOV                  \ get d2-lo
   0 [EBP] EAX SUB                  \ subtract d1-lo
   EAX 8 [EBP] MOV                  \ write d3-low
   4 [EBP] EBX SUB                  \ add d1-hi and carry to d2-hi
   EBX NEG
   8 # EBP ADD                      \ and clean up stack
   RET END-CODE
 
\ V*  multiplies 2 vectors and returns the signed result.
CODE V* ( v v -- v)   
   8 [EBP] EAX MOV                  \ 
   0 [EBP] MUL                      \ multiply, result in edx:eax
   EAX 8 [EBP] MOV                  \ replace second on stack with hi word
   \ Note that we add 8 to the stack pointer, so 8 [EBP] will be 0 [EBP]

   4 [EBP] EAX MOV                  \ 
   EBX MUL                          \ multiply, result in edx:eax
   EAX EBX MOV                      \ replace tos with hi word

   8 # EBP ADD                      \ discard unused stack space
   RET END-CODE
 
\ V*/  multiplies a vector by the 2 16 bit scalars on top of the
\    stack.  The result is a vector scaled by the ratio of the
\    second number on the stack over the number on top of the
\    stack.  The intermediate results of the operation are 64 bits
\    to avoid overflow error.
CODE V*/ ( v n1 n2 -- v')
   0 [EBP] ECX MOV                  \ get n1
   8 [EBP] EAX MOV                  \ get vx
   ECX IMUL                         \ n1*vx => edx:eax
   EBX IDIV                         \ n1*vx/n2 remainder in EDX, quotient in EAX
   EAX 8 [EBP] MOV                  \ replace second on stack with hi word
   \ Note that we add 8 to the stack pointer, so 8 [EBP] will be 0 [EBP]

   0 [EBP] ECX MOV                  \ get n1
   4 [EBP] EAX MOV                  \ get vx
   ECX IMUL                         \ n1*vx => edx:eax
   EBX IDIV                         \ n1*vx/n2 remainder in EDX, quotient in EAX
   EAX EBX MOV                      \ quotient in tos

   8 # EBP ADD                      \ clean up stack
   RET END-CODE
 
\ ******************************************************************************
\  936  Vector arithmetic con't
\ ******************************************************************************

\ VABS  returns the absolute values of the vector on the stack.
CODE VABS ( y x -- |y| |x| ) ( n1 -- +n2 )
   
   0 [EBP] EAX MOV
   EAX EAX OR            \ check ebx
   0< IF                 \ if negative
      EAX NEG            \ negate again, making positive
      EAX 0 [EBP] MOV
   THEN                 

   EBX EBX OR            \ check ebx
   0< IF                 \ if negative
      EBX NEG            \ negate again, making positive
   THEN                 
   RET   END-CODE

 
\ VNEGATE  negates the vector on top of the stack.
CODE VNEGATE ( v -- v')   
   0 [EBP] EAX MOV
   EAX NEG            \ change sign of vy 
   EAX 0 [EBP] MOV

   EBX NEG            \ change sign of vx
   RET   END-CODE
 
\ YNEGATE  negates the y coordinate only.
CODE YNEGATE ( y x -- y' x)      0 [EBP] EAX MOV
   EAX NEG            \ change sign of vy 
   EAX 0 [EBP] MOV
   RET   END-CODE

\ ******************************************************************************
\  609  VECTOR Variables
\ ******************************************************************************

#USER    

CELL +USER () 
CELL +USER 'LABEL

TO #USER

\ (X) sets  ()  to 0, the address of the 1st cell is returned;
: (X) ( -- )   0 () ! ;
(X)
 
\ (Y) sets  ()  to 4, the address of the 2nd cell is returned.
: (Y) ( -- )   cell () ! ;
 
\ VECTOR  is a defining word that defines variables               
\   containing two 32-bit cells whose run-time behavior is to    
\   put on the stack the address of the cell that                
\   corresponds to the indexing variable,  () .  When            
\ (X) sets  ()  to 0, the address of the 1st cell is returned;    
\ (Y) sets  ()  to 4, the address of the 2nd cell is returned.    

CODE (VECTOR)
   EAX POP          \ return address points to data (offset)
   PUSH(EBX)        \ push a stack item onto the stack
   ESI EBX MOV      \ get base of user area
   0 [EAX] EBX ADD  \ and add value from body to it
   () [U] EBX ADD   \ add the value in () 
   RET   END-CODE

: VECTOR ( n -- )   #USER dup 2 cells +  dup to #USER  
   dup |CB-USER| >= if
      CR >IN @ >R  BL WORD COUNT
      ." user variable " TYPE ."  exceeds callback limit"
      R> >IN !
   else
      drop
   then  
   HEADER  POSTPONE (VECTOR)  , ;

\ 'ORIGIN  and  FRAME  are two vector variables.  'ORIGIN
\    is used to mark the lower and left-most limits of world-
\    coordinates.  FRAME  marks the upper and right-most limits
\    of same.  SetSize  and  SetOrigin  set  FRAME  and  'ORIGIN.
VECTOR 'ORIGIN   

VECTOR FRAME   

VECTOR #PLACES 
 
VECTOR REACH     VECTOR LOW    

TO #USER 

\ ******************************************************************************
\ ******************************************************************************
\ ******************************************************************************

\ A font structure has the following fields :
0
   cell struct oHeaderLength    
   cell struct oPixelsPerGlyphX    
   cell struct oPixelsPerGlyphY    
   cell struct oBitsPerPixel       
   cell struct oOctetsPerGlyphX    
   cell struct oOctetsPerGlyphTotal
   cell struct oExtraSpacingX    
   cell struct oExtraSpacingY    
   cell struct oFontTableLength    
constant |FontHeader|

variable vCurrentFont   \ pointer to the current font structure

variable vHeaderLength
variable vPixelsPerGlyphX     
variable vPixelsPerGlyphY     
variable vBitsPerPixel        
variable vOctetsPerGlyphX     
variable vOctetsPerGlyphTotal 
variable vExtraSpacingX 
variable vExtraSpacingY 
variable vFontTableLength

variable vFontTable     

: FontSet ( font -- )
   dup vCurrentFont !
   >r 
   r@ oHeaderLength        + @ vHeaderLength ! 
   r@ vHeaderLength @ + vFontTable !   \ for faster access at run time
   r@ oPixelsPerGlyphX     + @ vPixelsPerGlyphX     !
   r@ oPixelsPerGlyphY     + @ vPixelsPerGlyphY     !
   r@ oBitsPerPixel        + @ vBitsPerPixel        !
   r@ oOctetsPerGlyphX     + @ vOctetsPerGlyphX     !
   r@ oOctetsPerGlyphTotal + @ vOctetsPerGlyphTotal !
   r@ oExtraSpacingX       + @ vExtraSpacingX       !
   r@ oExtraSpacingY       + @ vExtraSpacingY       !
   r@ oFontTableLength     + @ vFontTableLength     !
   r> drop
;

variable vSavedCurrentFont

: FontNew ( font -- )
   vSavedCurrentFont @ over = if  drop  exit  then 
   vCurrentFont @ vSavedCurrentFont !
   FontSet
;

: FontRestore ( -- )
   vCurrentFont @ vSavedCurrentFont @ = if  exit  then
   vSavedCurrentFont @ 0= if  exit  then   
   vSavedCurrentFont @ FontSet
;

{ 
\ defines named character fonts, initializing the referencing variables above.
: (FONT:) ( y x -- )   CREATE  HERE ,  ,  ,  DOES>
   >r
   r@ @ 'LOCAL-FONT !  
   r> cell + 2@  swap vPixelsPerGlyphY !  vPixelsPerGlyphX !
   vPixelsPerGlyphX @ 7 + 8 / vOctetsPerGlyphX !
   vOctetsPerGlyphX @ vPixelsPerGlyphY @ * vOctetsPerGlyphTotal !
\   1 1 *FONT 2! 
;    
\ ' DROP 'FONT !

\ FONT:  compiles the .FNT file that corresponds to the character
\    font before defining it.
: FONT: ( y x -- )   
   >IN @ >R  (FONT:)  R> >IN !  BL WORD  dup COUNT +  s" .FNT"  ROT SWAP CMOVE  COUNT 4 +  R/O OPEN-FILE 
   if  cr ." Could not open file "  type  #1234 throw  then  
   ( file handle ) >r
   HERE  
   BEGIN  
      HERE #1024 dup ALLOT  R@ READ-FILE if  
         r@ CLOSE-FILE drop  cr  ." Could not read file "  1234 throw  
      then
   #1024 < UNTIL  
   R> CLOSE-FILE drop  
   LAST @ N>BODY ! ; 

\ Font8X16  ,  Font9X14  ,  Font8X8  and  Font6X7  are the supplied fonts.
16 8 FONT: Font8X16  14 9 FONT: Font9X14  8 8 FONT: Font8X8  7 6 FONT: Font6X7 
24 32 FONT: Font24x32ubuntu
}

: ShowFont ( -- )
   cr ." Font struct address  = "  vCurrentFont         @ $8.hex
   cr ." vHeaderLength        = "  vHeaderLength        @ $2.hex
   cr ." vPixelsPerGlyphX     = "  vPixelsPerGlyphX     @ .
   cr ." vPixelsPerGlyphY     = "  vPixelsPerGlyphY     @ .
   cr ." vBitsPerPixel        = "  vBitsPerPixel        @ .
   cr ." vOctetsPerGlyphX     = "  vOctetsPerGlyphX     @ .
   cr ." vOctetsPerGlyphTotal = "  vOctetsPerGlyphTotal @ .
   cr ." vExtraSpacingX       = "  vExtraSpacingX       @ .   
   cr ." vExtraSpacingY       = "  vExtraSpacingY       @ .   
   cr ." vFontTableLength     = "  vFontTableLength     @ $4.hex 
   cr ." vFontTable address   = "  vFontTable           @ $8.hex
;

\ include Font11x16x1.f
\ include Font5x8x1.f
\ include Font6x7x1.f
include Font1x1x1.f
include Font5x7x1.f
include Font8x8x1.f
include Font8x16x1.f
include Font12x16x1.f
include Font17x24x1.f
include Font24x32x1.f

: BIG[  ( -- )   Font24x32x1 FontNew ;
: ]BIG ( -- )   FontRestore ;

: PixelAt-XY ( x y -- )
   vCurrentFont @ >r
   Font1x1x1 FontSet    \ use the special 1x1 pixel font
   At-XY
   r> FontSet           
;

: ShowTitleNew ( $ -- )
\   ShowTitle  exit
\   0 WinX !  20 WinY !
\   Font24x32x1 FontSet
   BIG[
   #32 #04 PixelAt-XY
   0 max #40 min Type 
   ]BIG
\   Font8x16x1 FontSet
;

variable StartOfFontChar

: .Line ( w -- )
   dup 8.hex 2 spaces 
   vPixelsPerGlyphX @ 0 ?do 
      dup $0001 and if  ( ." X" ) vTextForegroundColour @  else  ( ." ." ) vTextBackgroundColour @  then
      vTextForegroundColour @ = if  ." *"  else  ." ."  then 
      1 rshift 
   loop
   drop
;

{ 
: x3c@ ( a -- u )   BE@ >h< ;
: 3c@ ( a -- u )   >r r@ 3 + c@ 8 lshift r@ c@ or 8 lshift r> 1 + c@ or ; 
: 3c! ( u a -- )   >r 
   dup $ff and r@ c!
   dup 8 rshift $ff and r@ 1 + c! 
   #16 rshift $ff and r@ 2 + c!
   r> drop
;

: Mangle ( a -- )
   >r r@ 3c@  r> 3c! 
;

: Mangles ( -- )
   $2400 0 do
      vFontTable @ i + Mangle
   3 +loop
;
}

variable FlipResult
variable FlipMask

: flip12 ( w -- w' )
   >< 4 rshift
   exit
   1 FlipMask !
   ><
   #16 0 do 
      dup FlipMask @ and if  1  else  0  then
      FlipResult @ 1 lshift or FlipResult !
      FlipMask @ 1 lshift FlipMask !
   loop
   drop
   FlipResult @
;

: .Char ( c -- )
   vOctetsPerGlyphTotal @ *  vFontTable @ + StartOfFontChar !
   vPixelsPerGlyphY @ 0 ?do
      cr \ i 1 and 0= if  cr  then 
      StartOfFontChar @ w@ $FFFF and flip12 .Line
      vOctetsPerGlyphX @ StartOfFontChar +!
   loop
;

: ttFont17  
   1234 vTextForegroundColour !
   0 vTextBackgroundColour !
   Font12x16x1 FontSet
\   Font11x16x1 FontSet
\   Font17x24x1 FontSet
\   Font24x32x1 FontSet
   ShowFont
   $34 $30 do  
      cr ." ----------- "  i 2.hex space i emit 
      i .Char  
   loop
\   StartOfFontChar @ vOctetsPerGlyphTotal @ dump 
\ : (CopyGlyphLine2) ( w -- )
;

\ Font24x32ubuntu
\ Font8X8
\ Font8X16
\ Font9X14

{ 
#03 constant OCTETS_PER_GLYPH_LINE
OCTETS_PER_GLYPH_LINE 8 * constant PIXELS_PER_GLYPH_LINE
#32 constant NUMBER_OF_GLYPH_LINES
OCTETS_PER_GLYPH_LINE NUMBER_OF_GLYPH_LINES * constant OCTETS_PER_GLYPH
}

\ #01 constant OCTETS_PER_GLYPH_LINE
{ 
OCTETS_PER_GLYPH_LINE 8 * constant PIXELS_PER_GLYPH_LINE
#16 constant NUMBER_OF_GLYPH_LINES
OCTETS_PER_GLYPH_LINE NUMBER_OF_GLYPH_LINES * constant OCTETS_PER_GLYPH 
}
\ #16 constant NUMBER_OF_GLYPH_LINES
\ #1024 constant PIXELS_PER_BITMAP_LINE
\ #768  constant LINES_PER_SCREEN

DRAWING_SIZE_X  DRAWING_SIZE_Y * cells constant OCTETS_PER_SCREEN     

\ OCTETS_PER_GLYPH_LINE NUMBER_OF_GLYPH_LINES * constant OCTETS_PER_GLYPH

variable GlyphAddress   \ the address of the glyph pattern
variable BitmapAddress  \ the address to write to in the bitmap memory 

0 FramePtr ! 

\ *****************************************************************************
\ Direct "drawing to bitmap from font" Glyph code
\ *****************************************************************************

\ set the address of the top left pixel at the current (x,y) location in the Bitmap window
\ Each line in the Bitmap window is 1024 cells long
: SetBitmapDestinationAddress ( -- )   
   WinX @   
   WinY @  DRAWING_SIZE_X * + 
\   X-ORG + 
   cells \ 1 cell per pixel data
\   OCTETS_PER_SCREEN DRAWING_SIZE_X cells - min 
   FramePtr @ + BitmapAddress ! 
;

: (CopyGlyphLine1) ( -- )
   GlyphAddress @ c@  
   vPixelsPerGlyphX @ 0 ?do 
      dup $80 and if  ( ." X" ) vTextForegroundColour @  else  ( ." ." ) vTextBackgroundColour @  then
      BitmapAddress @ i cells + !  
      1 lshift  
   loop
   drop
;

: (CopyGlyphLine2) ( w -- )
   GlyphAddress @ w@  >< 4 rshift
   vPixelsPerGlyphX @ 0 ?do 
      dup $0001 and if  ( ." X" ) vTextForegroundColour @  else  ( ." ." ) vTextBackgroundColour @  then
      BitmapAddress @ i cells + !  
      1 rshift  
   loop
   drop
;

: (CopyGlyphLine3) ( a -- )
   GlyphAddress @ BE@   \ 2 lshift
   vPixelsPerGlyphX @ 0 ?do 
      dup $8000000 and if  ( ." X" ) vTextForegroundColour @  else  ( ." ." ) vTextBackgroundColour @  then
      BitmapAddress @ i cells + !  
      1 lshift  
   loop
   drop
;

: CopyGlyphLine ( u -- )   
   vOctetsPerGlyphX @ case
   1 of  (CopyGlyphLine1)  endof
   2 of  (CopyGlyphLine2)  endof
   3 of  (CopyGlyphLine3)  endof
      (CopyGlyphLine1)
   endcase
   vOctetsPerGlyphX @ GlyphAddress +!     \ update the pointer to the Glyph source 
   DRAWING_SIZE_X cells BitmapAddress +!  \ update the pointer to the bitmap memory destination
;

{ 
: CopyBlankGlyphLine ( -- )
   0 \ GlyphAddress @ c@  
   vPixelsPerGlyphX @ 0 ?do 
      dup $80 and if  ( ." X" ) vTextForegroundColour @  else  ( ." ." ) vTextBackgroundColour @  then
      BitmapAddress @ i cells + !  
      1 lshift  
   loop
   drop
;
}

: CopyGlyph ( a -- )

   GlyphAddress !

   SetBitmapDestinationAddress

   vPixelsPerGlyphY @ 0 ?do 
      CopyGlyphLine  
   loop
\   vExtraSpacingY @ 0 ?do
\      CopyBlankGlyphLine   
\   loop
;

: Emit(F) ( c -- )   \ 
   vOctetsPerGlyphTotal @ * vFontTable @ + CopyGlyph
   vPixelsPerGlyphX @ vExtraSpacingX @ + WinX +!   \ move to the right by 1 character
;

\ *****************************************************************************
\ 
\ *****************************************************************************
{ 
variable HighlightMe

: doWinEMIT ( -- )   
   ptrTextBuffer @ >r         \ offset in text buffer
   r@ c@ if 
      r@ CHARS-PER-SCREEN +   \ offset from text buffer to colour attribute buffer
      c@ dup >r 
      HighlightMe @ if  1+  then 
      $7F and >RGB  vTextBackgroundColour !  vTextForegroundColour !     
      r> $80 and if \ BIG font
         Font24x32x1 FontNew
         r@ c@ Emit(F)      
         FontRestore
      else
         r@ c@ Emit(F)           
      then
   then
   r> drop
;

: xxxWinLine ( line -- )
   CHARS-PER-LINE * TextBuffer[]  + ptrTextBuffer !
   CHARS-PER-DISPLAYED-LINE 0 do  
      doWinEMIT  
      1 ptrTextBuffer +!      \ next character for next time
   loop
   vPixelsPerGlyphY @ vExtraSpacingY @ + WinY +!      \ move down one line
   0 WinX !
;
}

variable DisplayStartLine

variable DoNotOverwriteGraph

: DoNotOverwriteGraph? ( i -- f )   
   DoNotOverwriteGraph @ 0= if  
     drop  -1  
   else
     6 37 within not  
   then 
;


: InvalidateAll ( -- )
   HWND 0 0 InvalidateRect drop 
\   hWndMain 0 0 InvalidateRect
;

$04 cells Buffer: BitmapRect

: InvalidateMain ( -- )  \ mark the bitmap area in the left part of the window as needing to be drawn
   0                                 BitmapRect !           \ _In_     int  X,      
   0                                 BitmapRect cell + !    \ _In_     int  Y,               
   cMainWindowSizeX 3 4 */ 14 + vDisplaySizeX @ cMainWindowSizeX */  BitmapRect 2 cells + !    \ _In_     int  x',              
   cMainWindowSizeY vDisplaySizeY @ cMainWindowSizeY */              BitmapRect 3 cells + !    \ _In_     int  y',              
   HWND
   BitmapRect 0 InvalidateRect drop
;

variable ScreenResource

{ 
\ UpdateText the text window from the text buffer
: xxxUpdateTextWindow ( -- )

   ScreenResource get

   0 WinX !  0 WinY !  \ position in pixels for the top left corner of the text display

   DISPLAYED-LINES-PER-SCREEN DisplayStartLine @ - 0 max  0 ?do
\      i 0 0 SP@ GetCursorPos DROP drop ( MouseY_Chars @ ) = HighlightMe !  
      i WinLine
   loop
   0 HighlightMe !

   0 WinX !  0 WinY !  \ position in pixels for the top left corner of the text display

\   ?WinUpdateText
\   depth FarDepth !

   ScreenResource release
;
} 

: NOOP1   0 ;

: KEY(T) ( -- c )   begin  2 ms  TheKeyPressed# @ until  TheKeyPressed @  0 TheKeyPressed# ! ;
: KEY?(T) ( -- f )   TheKeyPressed# @  ;
: EKEY(T) ( -- c )    KEY(T) ;
: EKEY?(T) ( -- f )   KEY?(T) ;
: AKEY(T) ( -- c )    KEY(T) ;

: ACCEPT(T) ( c-addr +n1 -- +n2 )   \ Forth 94
   OVER + 1- OVER          \ SA EA A
   BEGIN 
      KEY                  \ SA EA A C
   DUP $0D <> WHILE
      DUP $1B = IF  
         DROP DUP C@ EMIT   
      ELSE
         DUP 8 = IF  
            EMIT BL EMIT 8 EMIT 2- >R OVER 1- R> UMAX 
         ELSE
            DUP EMIT  OVER C!
         THEN 
      THEN 
      1+ OVER UMIN         \ SA EA A
   REPEAT                  \ SA EA A C
   DROP NIP - NEGATE 
;


CREATE TEXT-CONSOLE
   7 CELLS ,            \ datasize
        20 ,            \ maxvector
         0 ,            \ PHANDLE
         0 ,            \ PREVIOUS
         0 ,            \ inh
         0 ,            \ outh
         0 ,            \ c#
   ' NOOP ,             \ INVOKE    ( -- )
   ' NOOP ,             \ REVOKE    ( -- )
   ' NOOP ,             \ /INPUT    ( -- )
   ' emit(T) ,          \ EMIT      ( char -- )
   ' type(T) ,          \ TYPE      ( addr len -- )
   ' type(T) ,          \ ?TYPE     ( addr len -- )
   ' cr(T) ,            \ CR        ( -- )
   ' page(T) ,          \ PAGE      ( -- )
   ' attribute(T) ,     \ ATTRIBUTE ( n -- )
   ' KEY(T) ,           \ KEY       ( -- char )
   ' KEY?(T) ,          \ KEY?      ( -- flag )
   ' EKEY(T) ,          \ EKEY      ( -- echar )
   ' EKEY?(T) ,         \ EKEY?     ( -- flag )
   ' AKEY(T) ,          \ AKEY      ( -- char )
   ' 2DROP ,            \ PUSHTEXT  ( addr len -- )
   ' At-XY(T) ,         \ At-XY     ( x y -- )
   ' Get-XY?(T) ,       \ Get-XY?   ( -- x y )
   ' 2DUP ,             \ GET-SIZE  ( -- x y )
   ' ACCEPT(T) ,        \ Accept    ( addr u1 -- u2)
   ' 2drop ,            \ PixelAt-XY ( x y -- )


: >Told   TEXT-CONSOLE OPEN-PERSONALITY ;
: >H   CLOSE-PERSONALITY ;

: ForceKeyPress ( u -- )   \ pretend that the user pressed the ekey u
   TheKeyPressed !
   -1 TheKeyPressed# !
;

: KEY(F) ( -- c )  
   0 MouseButtonsPressed !
   begin  
      2 ms  
      MouseButtonsPressed @ if 
         $1B TheKeyPressed !
         -1 TheKeyPressed# !
         0 MouseButtonsPressed !
      then
   TheKeyPressed# @ until  
   TheKeyPressed @  
   0 TheKeyPressed# ! 
;

: KEY?(F) ( -- f )   TheKeyPressed# @ ;
: EKEY(F) ( -- c )    KEY(F) ;
: EKEY?(F) ( -- f )   KEY?(F) ;
: AKEY(F) ( -- c )    KEY(F) ;

: ACCEPT(F) ( c-addr +n1 -- +n2 )   \ Forth 94
   OVER + 1- OVER          \ SA EA A
   BEGIN 
      KEY                  \ SA EA A C
   DUP $0D <> WHILE
      DUP $1B = IF  
         DROP DUP C@ EMIT   
      ELSE
         DUP 8 = IF  
            EMIT BL EMIT 8 EMIT 2- >R OVER 1- R> UMAX 
         ELSE
            DUP EMIT  OVER C!
         THEN 
      THEN 
      1+ OVER UMIN         \ SA EA A
   REPEAT                  \ SA EA A C
   DROP NIP - NEGATE 
;


: type(F)         \ c-addr len --
   bounds ?do  i c@ emit(F)  loop
;

: attribute(F) ( n -- )   $7F and >RGB  vTextBackgroundColour !  vTextForegroundColour ! ;

: At-XY(F) ( column row -- )   
   l# ! c# ! 
   c# @ vPixelsPerGlyphX @ vExtraSpacingX @ + * WinX !  
   l# @ vPixelsPerGlyphY @ vExtraSpacingY @ + * WinY !
   SetBitmapDestinationAddress
;

: PixelAt-XY(F) ( x y -- )   
   WinY !
   WinX !  
   SetBitmapDestinationAddress
;

: Get-XY?(F) ( -- x y )   c# @ l# @ ;

: cr(F)     \ cr action
   Get-XY?(F)  swap drop 0  swap  1+  At-XY(F)
;

\ WASH  fills the entire display with the current background colour
: WASH ( rgb -- )
   BGR>RGB
   FramePtr @
   DRAWING_SIZE_X DRAWING_SIZE_Y * cells 0 do
      2dup i + !
   cell +loop
   2drop
;

: page(F)
   0 attribute(F)
   vTextBackgroundColour @ Wash
   0 0 At-XY(F)
;

CREATE TEXT-DISPLAY
   7 CELLS ,            \ datasize
        20 ,            \ maxvector
         0 ,            \ PHANDLE
         0 ,            \ PREVIOUS
         0 ,            \ inh
         0 ,            \ outh
         0 ,            \ c#
   ' NOOP ,             \ INVOKE    ( -- )
   ' NOOP ,             \ REVOKE    ( -- )
   ' NOOP ,             \ /INPUT    ( -- )
   ' emit(F) ,          \ EMIT      ( char -- )
   ' type(F) ,          \ TYPE      ( addr len -- )
   ' type(F) ,          \ ?TYPE     ( addr len -- )
   ' cr(F) ,            \ CR        ( -- )
   ' page(F) ,          \ PAGE      ( -- )
   ' attribute(F) ,     \ ATTRIBUTE ( n -- )
   ' KEY(F) ,           \ KEY       ( -- char )
   ' KEY?(F) ,          \ KEY?      ( -- flag )
   ' EKEY(F) ,          \ EKEY      ( -- echar )
   ' EKEY?(F) ,         \ EKEY?     ( -- flag )
   ' AKEY(F) ,          \ AKEY      ( -- char )
   ' 2DROP ,            \ PUSHTEXT  ( addr len -- )
   ' At-XY(F) ,         \ At-XY     ( x y -- )
   ' Get-XY?(F) ,       \ Get-XY?   ( -- x y )
   ' 2DUP ,             \ GET-SIZE  ( -- x y )
   ' ACCEPT(F) ,        \ Accept    ( addr u1 -- u2)
   ' PixelAt-XY(F) ,    \ PixelAt-XY ( x y -- )

: >T   TEXT-DISPLAY OPEN-PERSONALITY ;

: ShowAllChars ( -- )   
   >t  
   page  $100 0 do  i $0F and 0= i 0= not and if  cr  then  i emit  loop  
   >h ;

: asd1 ( -- )   Font5x7x1   FontSet  ShowAllChars ;
: asd8 ( -- )   Font8x8x1   FontSet  ShowAllChars ;
: asd2 ( -- )   Font8x16x1  FontSet  ShowAllChars ;
: asd3 ( -- )   Font24x32x1 FontSet  ShowAllChars ;
: asd33 ( -- )  Font24x32x1 FontSet  ShowAllChars ;
: asd17 ( -- )  Font17x24x1 FontSet  ShowAllChars ;
      
: ShowFont8 ( c -- )
   8 0 do  
      dup i 2** and if  ." *"  else  ."  "  then      
   loop
   drop
;

: ZXC ( n -- )
   $10 * Font8x8x1 + 
   $10 0 do  
      cr 
      dup i + c@ dup 2 .hex  2 spaces  ShowFont8
   loop
;

                                               
variable DisplayUpdateTaskDone                 
variable LastScreenNumber

\ ****************************************************************************
\ rotating wheel and bar status displays
\ ****************************************************************************
variable WheelState

: CLEAN ( -- )   GET-XY >r drop 0 r> CHARS-PER-DISPLAYED-LINE SPACES  At-XY ;

: Rpush ( n -- )   r> swap >r >r ;
: Rpop ( -- n )   r> r> swap >r ;
: 2Rpush ( d -- )   r> -rot 2>r >r ;
: 2Rpop ( -- d )   r> 2r> rot >r ;

: ttrs ( -- )     0 1234 Rpush 1+ Rpop . . ; 
: ttrs2 ( -- )     0 1234. 2Rpush 1+ 2Rpop d. . ; 

\ only one of these 
variable TextScreenFacility

#USER
cell +USER SavedMsgAttribute 
2 cells +USER SavedXY
to #USER

: yMSG< ( y -- )   
   >r
   Get-XY SavedXY 2!
   TextScreenFacility GET  
   CurrentAttribute @ SavedMsgAttribute !  
   0 r> At-XY  CLEAN 
;

: MSG< ( -- )    0 yMSG< ;
: MSG1< ( -- )   1 yMSG< ;
: MSG2< ( -- )   2 yMSG< ;
: MSG3< ( -- )   3 yMSG< ;

: >MSG ( -- )   
\   SavedMsgAttribute @ ATTRIBUTE+  
   SavedXY 2@ At-XY 
   TextScreenFacility RELEASE
;  
\ CR ." >>> "  SWAP . . DEPTH . CR EXIT At-XY ;

: ClearAllMSGs ( -- )
   MSG<   >MSG
   MSG1< >MSG
   MSG2< >MSG
   MSG3< >MSG
;

: ttrs3 ( n -- )  yMSG< ." Test line..." >MSG ;
: ttrs4  MSG<  ." Hello!" >MSG ;

: Wheel
   CurrentAttribute @ >r
   Get-XY 2>r
   WheelState @ case
   0 of  [char] -  endof
   1 of  [char] \  endof
   2 of  [char] |  endof
   3 of  [char] /  endof
   dup                     \ any other state, display the character
   endcase
   emit
   2r> At-XY
   WheelState @ 1 + 3 and  WheelState !
   r> ATTRIBUTE+
;

: WheelClear ( -- )   BL WheelState !  Wheel  ;


: TT1   >T  85 emit  86 emit  cr  >H ;
: tts   8 0 do  cr(F)  loop ;

{ 
2variable MyPoint

: xxxMousePosClientChars ( -- x y )
   0 0 SP@ GetCursorPos DROP  swap MyPoint cell+ !  MyPoint !

   HWND MyPoint ScreenToClient drop   \ convert to client window coordinates

   HWND GetWindowSize  drop 2swap 2drop ( -- Xsize Ysize )  \ get client window size, including borders  
   vBorderSizeY @ - 1 max                 \ remove the height of the borders
   swap  vBorderSizeX @ - 1 max  swap     \ remove the width of the borders
\   2dup swap . . 
   \ now we have the size of the drawing area, so scale to the character position
   >r 
   MyPoint       @  swap ( vStatusBarWidth  @ - 1 max )  CHARS-PER-DISPLAYED-LINE   swap */
   MyPoint cell+ @  r>   ( vStatusBarHeight @ - 1 max )  DISPLAYED-LINES-PER-SCREEN swap */ 
;

\ returns the x and y coordinates aof a 4 x 4 grid, 16 areas
: xxxMousePosClient4x4 ( -- x y )
   0 0 SP@ GetCursorPos DROP  swap MyPoint cell+ !  MyPoint !

   HWND MyPoint ScreenToClient drop   \ convert to client window coordinates

   HWND GetWindowSize  drop 2swap 2drop ( -- Xsize Ysize )  \ get client window size, including borders  
   vBorderSizeY @ - 1 max                 \ remove the height of the borders
   swap  vBorderSizeX @ - 1 max  swap     \ remove the width of the borders
\   2dup swap . . 
   \ now we have the size of the drawing area, so scale to the character position
   >r 
   MyPoint       @  swap ( vStatusBarWidth  @ - 1 max )  4  swap */
   MyPoint cell+ @  r>   ( vStatusBarHeight @ - 1 max )  4  swap */ 
;

: xxxMousePosClient ( -- x y )
   0 0 SP@ GetCursorPos DROP  swap MyPoint cell+ !  MyPoint !

   HWND MyPoint ScreenToClient drop   \ convert to client window coordinates

   HWND GetWindowSize  drop 2swap 2drop ( -- Xsize Ysize )  \ get client window size, including borders  
   vBorderSizeY @ - 1 max                 \ remove the height of the borders
   swap  vBorderSizeX @ - 1 max  swap     \ remove the width of the borders
\   2dup swap . . 
   \ now we have the size of the text area, so scale to the character position ( y is double resolution )
   >r 
   MyPoint       @  swap ( vStatusBarWidth  @ - 1 max )  DRAWING_SIZE_X swap */
   MyPoint cell+ @  r>   ( vStatusBarHeight @ - 1 max )  DRAWING_SIZE_Y swap */ 
;
} 

: MousePosClientAll ( -- )
   0 0 SP@ GetCursorPos DROP  MousePosition_X ! MousePosition_Y !  

   HWND MousePosition_X ScreenToClient drop   \ convert to client window coordinates

   HWND GetWindowSize  drop 2swap 2drop ( -- Xsize Ysize )  \ get client window size, including borders  
   vBorderSizeY @ - 1 max  WindowSize_Y !    \ remove the height of the borders
   vBorderSizeX @ - 1 max  WindowSize_X !    \ remove the width of the borders
   \ now we have the size of the text area, so scale to the character position 
   MousePosition_X @              DRAWING_SIZE_X  WindowSize_X @   */  MouseX_Pixels !
   MousePosition_Y @              DRAWING_SIZE_Y  WindowSize_Y @   */  MouseY_Pixels !
                                               
   MousePosition_X @                           4  WindowSize_X @   */  MouseX_4x4 !
   MousePosition_Y @                           4  WindowSize_Y @   */  MouseY_4x4 !
                                   
   MousePosition_X @  CHARS-PER-LINE              WindowSize_X @   */  MouseX_Chars !
   MousePosition_Y @  DISPLAYED-LINES-PER-SCREEN  WindowSize_Y @   */  MouseY_Chars !

;

\ 0 value TextConsoleInitialised

: InitTextConsole ( -- ) 
\   TextConsoleInitialised if  exit  then 
\   -1 to TextConsoleInitialised
   
\ Font24x32ubuntu
\ Font8X8
\ Font8X16
\ Font9X14
   
\   Font11x16x1  FontSet
\    Font8x16x1 FontSet
    Font12x16x1 FontSet
\   Font17x24x1 FontSet
\   Font24x32x1 FontSet
\   ShowFont
\   quit

   page(T)
   TEXT-CONSOLE 4 CELLS + 3 CELLS ERASE 

   0 NoScroll !   \ allow scrolling
   0 vBigFont !   \ normal font
;

:ONSYSLOAD ( -- )   InitTextCONSOLE ;

